<?php
/**
 * CadpessoaCadcontratoplgList Listing
 * @author  <your name here>
 */
class CadNcmIbpt extends TPage
{
    private $form; // form
    //private $datagrid; // listing
    //include_once('vendor/autoload.php');
    /**
     * Class constructor
     * Creates the page, the form and the listing
     */
    public function __construct()
    {
        parent::__construct();            
        // creates the form
        parent::__construct();   
        parent::include_js('app/lib/include/application.js');
        TPage::include_js('app/resources/eventosjs.js');      
     
        $this->form = new BootstrapFormBuilder('form_CadNcmIbpt');  
        $this->form->setFormTitle('Tabela IBPT');                 
        
        $tabelaibpt = new TFile('tabelaibpt');
        
        $this->form->addFields([new TLabel('Tabela Ibpt')],[$tabelaibpt]);
        
        $btn = $this->form->addAction('Importar', new TAction(array($this, 'onSave')), 'far:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addAction( _t('New'), new TAction(array($this, 'onEdit')), 'fa:eraser red');        
        //$this->form->addAction( _t('Back to the listing'), new TAction(array('SystemUserList','onReload')), 'fa:table blue');        
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        //$container->add(new TXMLBreadCrumb('menu.xml', 'SystemUserList'));
        $container->add($this->form);        
        parent::add($container);
    }
    
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            $conn = TTransaction::get(); // get PDO connection
            
            // make query
             
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            
            $data = $this->form->getData(); // get form data as array
            $uf = $data->tabelaibpt;
            $uf = $uf[12].$uf[13];
            
            if(!empty($uf))
            {
               $result = $conn->query("DELETE FROM " . Cadncm::TABLENAME . " WHERE uf='$uf'");            
            }
            /*
            $criteria = new TCriteria; 
            $criteria->add(new TFilter('uf',  '=', $uf)); 
            $repository = new TRepository(Cadncm::TABLENAME); 
            $repository->delete($criteria);
            */
            $row = 1;
            if (($handle = fopen('tmp/'.$data->tabelaibpt, "r")) !== FALSE) 
            {
                while (($data = fgetcsv($handle, 1000, ";")) !== FALSE) 
                {
                    if ($row > 1)
                    {
                        $object = new Cadncm;  // create an empty object
                        $object->ncm       = $data[0];
                        $object->ex        = $data[1];
                        $object->tipo      = $data[2];
                        $object->descricao = utf8_encode($data[3]);//iconv(mb_detect_encoding($text, mb_detect_order(), true), "UTF-8", $data[3]);
                        $object->nacionalfederal = $data[4];
                        $object->importadosfederal = $data[5];
                        $object->estadual = $data[6];
                        $object->aliqmunicipal= $data[7];
                        $object->vigenciainicio= TDate::date2us($data[8]);
                        $object->vigenciafim= TDate::date2us($data[9]);
                        $object->chave= $data[10];
                        $object->versao= $data[11];
                        $object->fonte= $data[12];
                        $object->uf= $uf;                        
                        //HDebug::raw($object);
                        //break;
                        $object->store(); // save the object   
                    /*
                    codigo;ex;tipo;descricao;
                    nacionalfederal;importadosfederal;estadual;municipal;vigenciainicio;vigenciafim;chave;versao;fonte                    
                    */                             
                    }
                    $row++;                    
                }
                fclose($handle);
            } 
             new TMessage('info', 'Impotação efetuada com sucesso!');
            $this->form->clear();//limpa formulario
            TTransaction::close(); // close the transaction
                        
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    function ValidaData($dat)
    {
        $data = explode("/","$dat");
        @$d = $data[0];
        @$m = $data[1];
        @$y = $data[2];
        return @checkdate($m,$d,$y);
    }        
}