<?php
/**
 * CadtipooperacaoForm Form
 * @author  <your name here>
 */
class CadtipooperacaoForm extends TPage
{
    protected $form; // form
    
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadtipooperacao');
        $this->form->setFormTitle('Tipo de Operação');
        

        // create the form fields
        $id = new TEntry('id');
        $descricao = new TEntry('descricao');
        $tipooperacao = new TCombo('tipooperacao');
        $tipoemitente = new TCombo('tipoemitente');
        $serie = new TEntry('serie');
        $modelodfe = new TCombo('modelodfe');
        $tiponatureza = new TCombo('tiponatureza');
        $chaveacessoobrigatorio = new TCombo('chaveacessoobrigatorio');
        $geracomissao = new TCombo('geracomissao');
        $geraestoque = new TCombo('geraestoque');
        $gerafaturamento = new TCombo('gerafaturamento');
        $faturaautomatico = new TCombo('faturaautomatico');
        $usavendedor = new TCombo('usavendedor');
        $usacondpgto = new TCombo('usacondpgto');
        $editanumeronota = new TCombo('editanumeronota');
        $editadtemissao = new TCombo('editadtemissao');
        $editadtentrada = new TCombo('editadtentrada');
        $editanaturezaoperacao = new TCombo('editanaturezaoperacao');
        $estoquenegativo = new TCombo('estoquenegativo');
        $estoquenegativosenha = new TCombo('estoquenegativosenha');
        $usaoutrasfreteseguro = new TCombo('usaoutrasfreteseguro');
        $usatransportador = new TCombo('usatransportador');
        $usadesconto = new TCombo('usadesconto');
        $usanaturezaoperacao = new TCombo('usanaturezaoperacao');
        $usaproduto = new TCombo('usaproduto');
        $itemusadesconto = new TCombo('itemusadesconto');
        $itemprodutoduplicado = new TCombo('itemprodutoduplicado');
        $itemservicoduplicado = new TCombo('itemservicoduplicado');
        $itemeditavalor = new TCombo('itemeditavalor');
        $itemvendedor = new TCombo('itemvendedor');
        $itemvendedorobrigatorio = new TCombo('itemvendedorobrigatorio');
        $itemvendedorautomatico = new TCombo('itemvendedorautomatico');
        $itemeditanaturezaoperacao = new TCombo('itemeditanaturezaoperacao');
        $importaitens = new TCombo('importaitens');
        $alteracusto = new TCombo('alteracusto');
        $alteravenda = new TCombo('alteravenda');
        $tipooperacaorel = new TDBMultiSearch('tipooperacaorel', 'goldnotas', 'Cadtipooperacao', 'id', '{id} - {descricao}');
        $faturacopianumserie = new TCombo('faturacopianumserie');
        $fatcontrolasaldo = new TCombo('fatcontrolasaldo');
        $fateditaqtde = new TCombo('fateditaqtde');
        $fatprodutoservico = new TCombo('fatprodutoservico');
        $cadnaturezaoperacao_id = new TDBCombo('cadnaturezaoperacao_id','goldnotas','Cadnaturezaoperacao','id','{id_natureza} - {natureza}');
        //$cadnaturezaoperacao_id->setMask('<b> {id_natureza} - {natureza}</b>');        
        //$cadnaturezaoperacao_id->style = 'text-align:center;color: #;';
        
        //$cadnaturezaoperacao_id->enableSearch();
        //$cadnaturezaoperacao_id->setSize('50%');                      
        
        $descricao->addValidation('Descrição', new TRequiredValidator );
        $tipooperacao->addItems(diversosmovimento::listtipooperacao());
        $tipooperacao->addValidation('Tipo de Operação', new TRequiredValidator );
        $tiponatureza->setChangeAction( new TAction( array($this, 'onChangetiponatureza')) );        
        
        
        $itens = array();
        $itens['1'] = 'Empresa';
        $itens['2'] = 'Cliente/Fornecedor';
        $tipoemitente->addItems($itens);

        $itens = array();
        $itens['E'] = 'Entrada';
        $itens['S'] = 'Saída';
        $tiponatureza ->addItems($itens); 
        $usanaturezaoperacao->addItems(s7sdiversos::listsimnao());
        $editanaturezaoperacao->addItems(s7sdiversos::listsimnao());       
        
        $modelodfe->addItems(diversosdfe::listmodelodfe());
        
        $usaproduto->addItems(s7sdiversos::listsimnao());
        $geraestoque->addItems(s7sdiversos::listsimnao());
        $estoquenegativo->addItems(s7sdiversos::listsimnao());
        $estoquenegativosenha->addItems(s7sdiversos::listsimnao());        
        $usacondpgto->addItems(s7sdiversos::listsimnao());
        $usavendedor->addItems(s7sdiversos::listsimnao());
        $editanumeronota->addItems(s7sdiversos::listsimnao());
        $editadtemissao->addItems(s7sdiversos::listsimnao());
        $editadtentrada->addItems(s7sdiversos::listsimnao());
        $usadesconto->addItems(s7sdiversos::listsimnao());
        $usaoutrasfreteseguro->addItems(s7sdiversos::listsimnao());
        $usatransportador->addItems(s7sdiversos::listsimnao());
        $geracomissao->addItems(s7sdiversos::listsimnao());
        $faturaautomatico->addItems(s7sdiversos::listsimnao());
        $gerafaturamento->addItems(s7sdiversos::listsimnao());
        $itemeditanaturezaoperacao->addItems(s7sdiversos::listsimnao());
        $itemeditavalor->addItems(s7sdiversos::listsimnao());
        $itemprodutoduplicado->addItems(s7sdiversos::listsimnao());
        $itemservicoduplicado->addItems(s7sdiversos::listsimnao());
        $itemusadesconto->addItems(s7sdiversos::listsimnao());
        $itemvendedor->addItems(s7sdiversos::listsimnao());
        $itemvendedorautomatico->addItems(s7sdiversos::listsimnao());
        $itemvendedorobrigatorio->addItems(s7sdiversos::listsimnao());
        $fatcontrolasaldo->addItems(s7sdiversos::listsimnao());
        $fateditaqtde->addItems(s7sdiversos::listsimnao());
        $faturaautomatico->addItems(s7sdiversos::listsimnao());
        $faturacopianumserie->addItems(s7sdiversos::listsimnao());
        
        $itens = array();
        $itens['A'] = 'Ambos';
        $itens['P'] = 'Produto';
        $itens['S'] = 'Serviço';        
        
        $fatprodutoservico->addItems($itens);


        
        $usatransportador->setValue('N');
        
        // add the fields   
        
        $labelprincipal = new TLabel('Principal', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );        
             
        $row = $this->form->addFields( [ new TLabel('Código') , $id ],
                                       [ new TLabel('Descrição') , $descricao ]);
        $row->layout = ['col-sm-1 control-label',
                        'col-sm-7 control-label'];                                               
        $row = $this->form->addFields( [ new TLabel('Tipo Operação') ,  $tipooperacao ],
                                       [ new TLabel('Serie') , $serie ],       
                                       [ new TLabel('Modelodfe') , $modelodfe ],
                                       [ new TLabel('Tipo Emitente') , $tipoemitente ]);
        $row->layout = ['col-sm-3 control-label',
                        'col-sm-1 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                                       
                
        $row = $this->form->addFields( [ new TLabel('Recebe Produto'), $usaproduto ], 
                                [ new TLabel('Movimenta Estoque'), $geraestoque ],                
                                [ new TLabel('Permite Estoque Negativo'), $estoquenegativo ],
                                [ new TLabel('Estoque Negativo Senha'), $estoquenegativosenha ] );                
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];
                        
        $row = $this->form->addFields( [ new TLabel('Usa Vendedor') , $usavendedor ],
                                       [ new TLabel('Usa CondPgto') , $usacondpgto ],
                                       [ new TLabel('Usa Outras/Frete/Seguro'), $usaoutrasfreteseguro ],
                                       [ new TLabel('Usa Transportadora'), $usatransportador ]);                        
        
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];
                        
        $row = $this->form->addFields( [ new TLabel('Edita Nr. Nota'), $editanumeronota ],
                                       [ new TLabel('Edita Dt.Emissão'), $editadtemissao ],
                                       [ new TLabel('Edita Dt.Entrada'), $editadtentrada ],
                                       [ new TLabel('Usa Desconto'), $usadesconto]);
                                       
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',                      
                        'col-sm-2 control-label',                        
                        'col-sm-2 control-label'];                                                                       
                        
        $labelprincipal = new TLabel('Financeiro', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );                        
                                                
        $row = $this->form->addFields( [ new TLabel('Gera Financeiro') , $gerafaturamento ],
                                       [ new TLabel('Gera Comissão'), $geracomissao ],         
                                       [ new TLabel('Faturamento Automático') , $faturaautomatico ] );
                                       
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',                      
                        'col-sm-2 control-label'];                                       
 
        $labelprincipal = new TLabel('Natureza de Operação', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] ); 
        
        $row = $this->form->addFields( [ new TLabel('Usa Natureza Operação') , $usanaturezaoperacao ], 
                                       [ new TLabel('Edita Natureza Operação') , $editanaturezaoperacao ],
                                       [ new TLabel('Tipo Natureza') , $tiponatureza ]);
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];
        $row = $this->form->addFields([ new TLabel('Natureza Operação') , $cadnaturezaoperacao_id]);                                                
        $row->layout = ['col-sm-8 control-label'];                        
                        
        $labelprincipal = new TLabel('Lançamento de Item', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );                         
                                       
        $row = $this->form->addFields( [ new TLabel('Desconto') , $itemusadesconto ],
                                       [ new TLabel('Produto Duplicado') ,  $itemprodutoduplicado ],
                                       [ new TLabel('Serviço Duplicado') ,  $itemservicoduplicado ],
                                       [ new TLabel('Edita Valor') , $itemeditavalor ] );
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];  
                                                      
        $row = $this->form->addFields( [ new TLabel('Vendedor') ,  $itemvendedor ],
                                       [ new TLabel('Vendedor Obrigatório') , $itemvendedorobrigatorio ],
                                       [ new TLabel('Vendedor Automático') , $itemvendedorautomatico ],
                                       [ new TLabel('Edita Natureza Operação') , $itemeditanaturezaoperacao ] );
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label']; 
                                                  
        $labelprincipal = new TLabel('Faturamento', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] ); 
                                                               
        $row = $this->form->addFields( [ new TLabel('Copia Número/Série') , $faturacopianumserie ],
                                       [ new TLabel('Controla Saldo') , $fatcontrolasaldo ],
                                       [ new TLabel('Edita Quantidade') , $fateditaqtde ],
                                       [ new TLabel('Produto/Serviço') , $fatprodutoservico ] );                                 
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                                
                                                                                               
        $row = $this->form->addFields( [ new TLabel('Tipo Operação Relacionado') , $tipooperacaorel ]);                                
        $row->layout = ['col-sm-8 control-label'];  
        
        $labelprincipal = new TLabel('Compras', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');  
        $this->form->addContent( [$labelprincipal] );         
                                                            
        $row = $this->form->addFields( [ new TLabel('Importa XML') , $importaitens ],
                                       [ new TLabel('Altera Pr.Custo') , $alteracusto ],
                                       [ new TLabel('Altera Pr.Venda') , $alteravenda ],
                                       [ new TLabel('Chave Acesso Obr.') , $chaveacessoobrigatorio ] );   
        $row->layout = ['col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label',
                        'col-sm-2 control-label'];                                                            

        // set sizes
        $id->setSize('100%');
        $descricao->setSize('100%');
        $tipooperacao->setSize('100%');
        $tipoemitente->setSize('100%');
        $serie->setSize('100%');
        $modelodfe->setSize('100%');
        $tiponatureza->setSize('100%');
        $chaveacessoobrigatorio->setSize('100%');
        $geracomissao->setSize('100%');
        $geraestoque->setSize('100%');
        $gerafaturamento->setSize('100%');
        $faturaautomatico->setSize('100%');
        $usavendedor->setSize('100%');
        $usacondpgto->setSize('100%');
        $editanumeronota->setSize('100%');
        $editadtemissao->setSize('100%');
        $editadtentrada->setSize('100%');
        $editanaturezaoperacao->setSize('100%');
        $estoquenegativo->setSize('100%');
        $estoquenegativosenha->setSize('100%');
        $usaoutrasfreteseguro->setSize('100%');
        $usatransportador->setSize('100%');
        $usadesconto->setSize('100%');
        $usanaturezaoperacao->setSize('100%');
        $usaproduto->setSize('100%');
        $itemusadesconto->setSize('100%');
        $itemprodutoduplicado->setSize('100%');
        $itemservicoduplicado->setSize('100%');
        $itemeditavalor->setSize('100%');
        $itemvendedor->setSize('100%');
        $itemvendedorobrigatorio->setSize('100%');
        $itemvendedorautomatico->setSize('100%');
        $itemeditanaturezaoperacao->setSize('100%');
        $importaitens->setSize('100%');
        $alteracusto->setSize('100%');
        $alteravenda->setSize('100%');
        $tipooperacaorel->setSize('100%');
        $faturacopianumserie->setSize('100%');
        $fatcontrolasaldo->setSize('100%');
        $fateditaqtde->setSize('100%');
        $fatprodutoservico->setSize('100%');
        //$cadnaturezaoperacao_id->setSize('100%');
        $cadnaturezaoperacao_id->setSize('100%');


        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        //$this->form->addActionLink(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadtipooperacaoList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadtipooperacaoList'));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Cadtipooperacao;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            //new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadtipooperacao($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public static function onChangetiponatureza($param)
    {
        try   
        {         
            $filtro = new TCriteria;                     
            $filtro->add(new TFilter('tiponatureza', '=', "{$param['tiponatureza']}"));                                   
            TDBCombo::reloadFromModel('form_Cadtipooperacao','cadnaturezaoperacao_id','goldnotas','cadnaturezaoperacao', 'id','{id_natureza} - {natureza}', null, $filtro, false, false);                       
 
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }                
        
    }
}
