<?php
/**
 * MovchequeForm Form
 * @author  <your name here>
 */
class MovimentoChequeForm extends TWindow
{
    protected $form; // form
    protected $datagrid;
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        parent::__construct();
        parent::setSize( 800, 720 );
        
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Movimentochequeform');
        $this->form->setFormTitle('Lançamento de Cheque');
        

        // create the form fields
        $id = new THidden('id');
        $numero = new TEntry('numero');
        $agencia = new TEntry('agencia');
        $banco = new TEntry('banco');
        $conta = new TEntry('conta');
        //$datalancamento = new TDate('datalancamento');
        $dataemissao = new TDate('dataemissao');
        $datavencimento = new TDate('datavencimento');
        $titular = new TEntry('titular');
        $titularcpfcnpj = new TEntry('titularcpfcnpj');
        $titulartelefone = new TEntry('titulartelefone');
        $valor = new TEntry('valor');
        /*
        $titular_cadpessoa_id = new TEntry('titular_cadpessoa_id');
        $cadsituacaocheque_id = new TDBUniqueSearch('cadsituacaocheque_id', 'goldnotas', 'Cadsituacaocheque', 'id', 'situacaocheque');
        $cadcaixacontacorrente_id = new TDBUniqueSearch('cadcaixacontacorrente_id', 'goldnotas', 'Cadcaixacontacorrente', 'id', 'pessoa');
        $portador_cadpessoa_id = new TEntry('portador_cadpessoa_id');
        $observacoes = new TEntry('observacoes');
        $portador = new TEntry('portador');
        $cadempresa_id = new TDBUniqueSearch('cadempresa_id', 'goldnotas', 'Cadempresa', 'id', 'empresa');
        $system_user_id = new TDBUniqueSearch('system_user_id', 'goldnotas', 'SystemUser', 'id', 'name');
        */

        // add the fields
        $this->form->addFields( [ $id ] );
        $row = $this->form->addFields( [ new TLabel('Banco') ,  $banco ],
                                       [ new TLabel('Agência') ,  $agencia ],
                                       [ new TLabel('Conta') ,  $conta ],                                
                                       [ new TLabel('Número') ,  $numero ],
                                       [ new TLabel('Valor') ,  $valor ] );
        $row->layout = ['col-sm-2','col-sm-2','col-sm-2','col-sm-3','col-sm-3'];                                                     
        //$this->form->addFields( [ new TLabel('Datalancamento') ], [ $datalancamento ] );
        $row = $this->form->addFields( [ new TLabel('Dt.Emissão') , $dataemissao ],
                                       [ new TLabel('Dt.Vencimento') ,  $datavencimento ],
                                       [ new TLabel('Titular') , $titular ]);
        $row->layout = ['col-sm-3','col-sm-3','col-sm-6'];
        
        $row = $this->form->addFields( [ new TLabel('CPF/CNPJ') , $titularcpfcnpj ],
                                       [ new TLabel('Telefone') , $titulartelefone ] );
        $row->layout = ['col-sm-4','col-sm-4'];                                               
        /*
        $this->form->addFields( [ new TLabel('Titular Cadpessoa Id') ], [ $titular_cadpessoa_id ] );
        $this->form->addFields( [ new TLabel('Cadsituacaocheque Id') ], [ $cadsituacaocheque_id ] );
        $this->form->addFields( [ new TLabel('Cadcaixacontacorrente Id') ], [ $cadcaixacontacorrente_id ] );
        $this->form->addFields( [ new TLabel('Portador Cadpessoa Id') ], [ $portador_cadpessoa_id ] );        
        $this->form->addFields( [ new TLabel('Observacoes') ], [ $observacoes ] );
        $this->form->addFields( [ new TLabel('Portador') ], [ $portador ] );
        $this->form->addFields( [ new TLabel('Cadempresa Id') ], [ $cadempresa_id ] );
        $this->form->addFields( [ new TLabel('System User Id') ], [ $system_user_id ] );
        */



        // set sizes
        //$id->setSize('100%');
        $numero->setSize('100%');
        $agencia->setSize('100%');
        $banco->setSize('100%');
        $conta->setSize('100%');
        //$datalancamento->setSize('100%');
        $dataemissao->setSize('100%');
        $datavencimento->setSize('100%');
        $titular->setSize('100%');
        $titularcpfcnpj->setSize('100%');
        $titulartelefone->setSize('100%');
        $valor->setSize('100%');
        /*
        $titular_cadpessoa_id->setSize('100%');
        $cadsituacaocheque_id->setSize('100%');
        $cadcaixacontacorrente_id->setSize('100%');
        $portador_cadpessoa_id->setSize('100%');
        $observacoes->setSize('100%');
        $portador->setSize('100%');
        $cadempresa_id->setSize('100%');
        $system_user_id->setSize('100%');
        */


        if (!empty($id))
        {
            $id->setEditable(FALSE);
        }
        
        
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        // make scrollable and define height
        $this->datagrid->setHeight(200);
        $this->datagrid->makeScrollable();        

        // creates the datagrid columns
        $column_banco          = new TDataGridColumn('banco',   'Banco',   'center', '15%');
        $column_agencia        = new TDataGridColumn('agencia', 'Agência', 'right','15%');                      
        $column_conta          = new TDataGridColumn('conta',   'Conta',   'left', '15%');
        $column_numero         = new TDataGridColumn('numnero', 'Número',  'left','25%');                              
        $column_dataemissaso   = new TDataGridColumn('dataemissao', 'Dt.Emissão',  'left','15%');
        $column_datavencimento = new TDataGridColumn('datavencimento', 'Dt.Vencimento',  'left','15%');
        
        //movimentoitem
        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_banco);
        $this->datagrid->addColumn($column_agencia);
        $this->datagrid->addColumn($column_conta);
        $this->datagrid->addColumn($column_numero);
        $this->datagrid->addColumn($column_dataemissaso);
        $this->datagrid->addColumn($column_datavencimento);     
        
        // create DELETE action
        $cheque_del = new TDataGridAction(array($this, 'onChequeDel'));
        $cheque_del->setLabel(_t('Delete'));
        $cheque_del->setImage('far:trash-alt red fa-lg');
        $cheque_del->setField('idmovimento');
        $this->datagrid->addAction($cheque_del);                         
                            
        // create the datagrid model
        $this->datagrid->createModel();        
        
        $this->form->addContent([TPanelGroup::pack('', $this->datagrid)]);
        //$this->form->addContent([ $this->datagrid ]);
        /** samples
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( '100%' ); // set size
         **/
         
        // create the form actions
        $btn = $this->form->addAction(_t('Save'), new TAction([$this, 'onSave']), 'fa:save');
        $btn->class = 'btn btn-sm btn-primary';
        $this->form->addActionLink(_t('New'),  new TAction([$this, 'onEdit']), 'fa:eraser red');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->form);
        
        parent::add($container);
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            TTransaction::open('goldnotas'); // open a transaction
            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
            $data = $this->form->getData(); // get form data as array
            
            $object = new Movcheque;  // create an empty object
            $object->fromArray( (array) $data); // load the object with data
            $object->store(); // save the object
            
            // get the generated id
            $data->id = $object->id;
            
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            
            new TMessage('info', AdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public function onChequeDel( $param )
    {
        
    }
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Movcheque($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                TTransaction::close(); // close the transaction
            }
            else
            {
                $this->form->clear(TRUE);
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
}
