<?php
/**
 * Cadalmoxarifado Active Record
 * @author  <your-name-here>
 */
class Cadalmoxarifado extends TRecord
{
    const TABLENAME = 'cadalmoxarifado';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadempresa;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);        
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('almoxarifado');
        parent::addAttribute('ativo');
    }

    
    /**
     * Method set_cadempresa
     * Sample of usage: $cadalmoxarifado->cadempresa = $object;
     * @param $object Instance of Cadempresa
     */
    public function set_cadempresa(Cadempresa $object)
    {
        $this->cadempresa = $object;
        $this->cadempresa_id = $object->id;
    }
    
    /**
     * Method get_cadempresa
     * Sample of usage: $cadalmoxarifado->cadempresa->attribute;
     * @returns Cadempresa instance
     */
    public function get_cadempresa()
    {
        // loads the associated object
        if (empty($this->cadempresa))
            $this->cadempresa = new Cadempresa($this->cadempresa_id);
    
        // returns the associated object
        return $this->cadempresa;
    }
}
