<?php
/**
 * Cadcaixa Active Record
 * @author  <your-name-here>
 */
class Cadcaixa extends TRecord
{
    const TABLENAME = 'cadcaixa';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcentrocusto;
    private $cadplanoconta;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('caixa');
        parent::addAttribute('ativo');
        parent::addAttribute('cadcentrocusto_id');
        parent::addAttribute('cadplanoconta_id');
    }

    
    /**
     * Method set_cadcentrocusto
     * Sample of usage: $cadcaixa->cadcentrocusto = $object;
     * @param $object Instance of Cadcentrocusto
     */
    public function set_cadcentrocusto(Cadcentrocusto $object)
    {
        $this->cadcentrocusto = $object;
        $this->cadcentrocusto_id = $object->id;
    }
    
    /**
     * Method get_cadcentrocusto
     * Sample of usage: $cadcaixa->cadcentrocusto->attribute;
     * @returns Cadcentrocusto instance
     */
    public function get_cadcentrocusto()
    {
        // loads the associated object
        if (empty($this->cadcentrocusto))
            $this->cadcentrocusto = new Cadcentrocusto($this->cadcentrocusto_id);
    
        // returns the associated object
        return $this->cadcentrocusto;
    }
    
    
    /**
     * Method set_cadplanoconta
     * Sample of usage: $cadcaixa->cadplanoconta = $object;
     * @param $object Instance of Cadplanoconta
     */
    public function set_cadplanoconta(Cadplanoconta $object)
    {
        $this->cadplanoconta = $object;
        $this->cadplanoconta_id = $object->id;
    }
    
    /**
     * Method get_cadplanoconta
     * Sample of usage: $cadcaixa->cadplanoconta->attribute;
     * @returns Cadplanoconta instance
     */
    public function get_cadplanoconta()
    {
        // loads the associated object
        if (empty($this->cadplanoconta))
            $this->cadplanoconta = new Cadplanoconta($this->cadplanoconta_id);
    
        // returns the associated object
        return $this->cadplanoconta;
    }
    


}
