<?php
/**
 * Cadpessoa Active Record
 * @author  <your-name-here>
 */
class Cadcaixacontacorrente extends TRecord
{
    const TABLENAME = 'cadpessoa';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $caixa_transf_cadpessoa;
    private $periodo_system_user;
    private $cc_cadplanoconta;
    private $cc_cadcentrocusto;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('pessoa');
        parent::addAttribute('tipocaixabanco');
        parent::addAttribute('nrcontacorrente');
        parent::addAttribute('nragencia');
        parent::addAttribute('cadbanco_id');
        parent::addAttribute('cc_cadcentrocusto_id');
        parent::addAttribute('cc_cadplanoconta_id');
        parent::addAttribute('ecaixacontacorrente');
        parent::addAttribute('ecaixaperiodo');
        parent::addAttribute('periodo_system_user_id');
        parent::addAttribute('caixa_transf_cadpessoa_id');
        parent::addAttribute('ativo');
        
    }

    
    /**
     * Method set_cadpessoa
     * Sample of usage: $cadpessoa->cadpessoa = $object;
     * @param $object Instance of Cadpessoa
     */
    public function set_caixa_transf_cadpessoa(Cadpessoa $object)
    {
        $this->caixa_transf_cadpessoa = $object;
        $this->caixa_transf_cadpessoa_id = $object->id;
    }
    
    /**
     * Method get_cadpessoa
     * Sample of usage: $cadpessoa->cadpessoa->attribute;
     * @returns Cadpessoa instance
     */
    public function get_caixa_transf_cadpessoa()
    {
        // loads the associated object
        if (empty($this->caixa_transf_cadpessoa))
            $this->caixa_transf_cadpessoa = new Cadpessoa($this->caixa_transf_cadpessoa_id);
    
        // returns the associated object
        return $this->caixa_transf_cadpessoa;
    }
    
    
    /**
     * Method set_system_user
     * Sample of usage: $cadpessoa->system_user = $object;
     * @param $object Instance of SystemUser
     */
    public function set_periodo_system_user(SystemUser $object)
    {
        $this->periodo_system_user = $object;
        $this->periodo_system_user_id = $object->id;
    }
    
    /**
     * Method get_system_user
     * Sample of usage: $cadpessoa->system_user->attribute;
     * @returns SystemUser instance
     */
    public function get_periodo_system_user()
    {
        // loads the associated object
        if (empty($this->periodo_system_user))
            $this->periodo_system_user = new SystemUser($this->periodo_system_user_id);
    
        // returns the associated object
        return $this->periodo_system_user;
    }
    
    
    /**
     * Method set_cadplanoconta
     * Sample of usage: $cadpessoa->cadplanoconta = $object;
     * @param $object Instance of Cadplanoconta
     */
    public function set_cc_cadplanoconta(Cadplanoconta $object)
    {
        $this->cc_cadplanoconta = $object;
        $this->cc_cadplanoconta_id = $object->id;
    }
    
    /**
     * Method get_cadplanoconta
     * Sample of usage: $cadpessoa->cadplanoconta->attribute;
     * @returns Cadplanoconta instance
     */
    public function get_cc_cadplanoconta()
    {
        // loads the associated object
        if (empty($this->cc_cadplanoconta))
            $this->cc_cadplanoconta = new Cadplanoconta($this->cc_cadplanoconta_id);
    
        // returns the associated object
        return $this->cc_cadplanoconta;
    }
    
    
    /**
     * Method set_cadcentrocusto
     * Sample of usage: $cadpessoa->cadcentrocusto = $object;
     * @param $object Instance of Cadcentrocusto
     */
    public function set_cc_cadcentrocusto(Cadcentrocusto $object)
    {
        $this->cc_cadcentrocusto = $object;
        $this->cc_cadcentrocusto_id = $object->id;
    }
    
    /**
     * Method get_cadcentrocusto
     * Sample of usage: $cadpessoa->cadcentrocusto->attribute;
     * @returns Cadcentrocusto instance
     */
    public function get_cc_cadcentrocusto()
    {
        // loads the associated object
        if (empty($this->cc_cadcentrocusto))
            $this->cc_cadcentrocusto = new Cadcentrocusto($this->cc_cadcentrocusto_id);
    
        // returns the associated object
        return $this->cc_cadcentrocusto;
    }
    


}
