<?php
/**
 * Cadcontador Active Record
 * @author  <your-name-here>
 */
class Cadcontador extends TRecord
{
    const TABLENAME = 'cadcontador';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcidade;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('contador');
        parent::addAttribute('endereco');
        parent::addAttribute('numero');
        parent::addAttribute('cep');
        parent::addAttribute('bairro');
        parent::addAttribute('complemento');
        parent::addAttribute('cadcidade_id');
        parent::addAttribute('telefone1');
        parent::addAttribute('telefone2');
        parent::addAttribute('email');
        parent::addAttribute('crc');
        parent::addAttribute('cpf');
        parent::addAttribute('cnpj');
        parent::addAttribute('ativo');
    }

    
    /**
     * Method set_cadcidade
     * Sample of usage: $cadcontador->cadcidade = $object;
     * @param $object Instance of Cadcidade
     */
    public function set_cadcidade(Cadcidade $object)
    {
        $this->cadcidade = $object;
        $this->cadcidade_id = $object->id;
    }
    
    /**
     * Method get_cadcidade
     * Sample of usage: $cadcontador->cadcidade->attribute;
     * @returns Cadcidade instance
     */
    public function get_cadcidade()
    {
        // loads the associated object
        if (empty($this->cadcidade))
            $this->cadcidade = new Cadcidade($this->cadcidade_id);
    
        // returns the associated object
        return $this->cadcidade;
    }
    


}
