<?php
/**
 * Cadformapgto Active Record
 * @author  <your-name-here>
 */
class Cadformapgto extends TRecord
{
    const TABLENAME = 'cadformapgto';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $adm_catao_cadpessoa;
    private $cadcentrocusto;
    private $cadplanoconta;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('tipo');
        parent::addAttribute('rec_dados_cheque');
        parent::addAttribute('ativo');
        parent::addAttribute('ver_limite');
        parent::addAttribute('ver_debitos');
        parent::addAttribute('ver_cadastro');
        parent::addAttribute('taxaadm');
        parent::addAttribute('lancar_liquido');
        parent::addAttribute('dias_vencimento');
        parent::addAttribute('tipocartao');
        parent::addAttribute('cadplanoconta_id');
        parent::addAttribute('cadcentrocusto_id');
        parent::addAttribute('adm_catao_cadpessoa_id');
    }

    public function get_desctipo()
    {
        $lista = s7sdiversos::listformapgto();
        return $lista[$this->tipo];        
    }  
    
    public function get_desctipocartao()
    {
        $lista = s7sdiversos::listtipoformapgtocartao();
        return $lista[$this->tipocartao];        
    }     
      
    /**
     * Method set_cadpessoa
     * Sample of usage: $cadformapgto->cadpessoa = $object;
     * @param $object Instance of Cadpessoa
     */
    public function set_adm_catao_cadpessoa(Cadpessoa $object)
    {
        $this->adm_catao_cadpessoa = $object;
        $this->adm_catao_cadpessoa_id = $object->id;
    }
    
    /**
     * Method get_cadpessoa
     * Sample of usage: $cadformapgto->cadpessoa->attribute;
     * @returns Cadpessoa instance
     */
    public function get_adm_catao_cadpessoa()
    {
        // loads the associated object
        if (empty($this->adm_catao_cadpessoa))
            $this->adm_catao_cadpessoa = new Cadpessoa($this->adm_catao_cadpessoa_id);
    
        // returns the associated object
        return $this->adm_catao_cadpessoa;
    }
    
    
    /**
     * Method set_cadcentrocusto
     * Sample of usage: $cadformapgto->cadcentrocusto = $object;
     * @param $object Instance of Cadcentrocusto
     */
    public function set_cadcentrocusto(Cadcentrocusto $object)
    {
        $this->cadcentrocusto = $object;
        $this->cadcentrocusto_id = $object->id;
    }
    
    /**
     * Method get_cadcentrocusto
     * Sample of usage: $cadformapgto->cadcentrocusto->attribute;
     * @returns Cadcentrocusto instance
     */
    public function get_cadcentrocusto()
    {
        // loads the associated object
        if (empty($this->cadcentrocusto))
            $this->cadcentrocusto = new Cadcentrocusto($this->cadcentrocusto_id);
    
        // returns the associated object
        return $this->cadcentrocusto;
    }
    
    
    /**
     * Method set_cadplanoconta
     * Sample of usage: $cadformapgto->cadplanoconta = $object;
     * @param $object Instance of Cadplanoconta
     */
    public function set_cadplanoconta(Cadplanoconta $object)
    {
        $this->cadplanoconta = $object;
        $this->cadplanoconta_id = $object->id;
    }
    
    /**
     * Method get_cadplanoconta
     * Sample of usage: $cadformapgto->cadplanoconta->attribute;
     * @returns Cadplanoconta instance
     */
    public function get_cadplanoconta()
    {
        // loads the associated object
        if (empty($this->cadplanoconta))
            $this->cadplanoconta = new Cadplanoconta($this->cadplanoconta_id);
    
        // returns the associated object
        return $this->cadplanoconta;
    }
    


}
