<?php
/**
 * CadpessoaCadcontratoplg Active Record
 * @author  <your-name-here>
 */
class CadpessoaCadcontratoplg extends TRecord
{
    const TABLENAME = 'cadpessoa_cadcontratoplg';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadpessoa;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadpessoa_id');
        parent::addAttribute('contrato_cadpessoa_id');
        parent::addAttribute('ativo');
        parent::addAttribute('dtemissao');
        parent::addAttribute('dtvencimento');
        parent::addAttribute('observacoes');
        parent::addAttribute('numero');
        parent::addAttribute('dtcadastro');
        parent::addAttribute('cadcontrato_id');
    }

    
    /**
     * Method set_cadpessoa
     * Sample of usage: $cadpessoa_cadcontratoplg->cadpessoa = $object;
     * @param $object Instance of Cadpessoa
     */
    public function set_cadpessoa(Cadpessoa $object)
    {
        $this->cadpessoa = $object;
        $this->cadpessoa_id = $object->id;
    }
    
    /**
     * Method get_cadpessoa
     * Sample of usage: $cadpessoa_cadcontratoplg->cadpessoa->attribute;
     * @returns Cadpessoa instance
     */
    public function get_cadpessoa()
    {
        // loads the associated object
        if (empty($this->cadpessoa))
            $this->cadpessoa = new Cadpessoa($this->cadpessoa_id);
    
        // returns the associated object
        return $this->cadpessoa;
    }   
    
    /**
     * Method set_cadcontrato
     * Sample of usage: $cadpessoa_cadcontratoplg->cadcontrato = $object;
     * @param $object Instance of Cadcontrato
     */
    public function set_cadcontrato(Cadcontrato $object)
    {
        $this->cadcontrato = $object;
        $this->cadcontrato_id = $object->id;
    }
    
    /**
     * Method get_cadcontrato
     * Sample of usage: $cadpessoa_cadcontratoplg->cadcontrato->attribute;
     * @returns Cadcontrato instance
     */
    public function get_cadcontrato()
    {
        // loads the associated object
        if (empty($this->cadcontrato))
            $this->cadcontrato = new Cadcontrato($this->cadcontrato_id);
    
        // returns the associated object
        return $this->cadcontrato;
    }     

}
