<?php
/**
 * Movcheque Active Record
 * @author  <your-name-here>
 */
class Movcheque extends TRecord
{
    const TABLENAME = 'movcheque';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcaixacontacorrente;
    private $cadsituacaocheque;
    private $portador_cadpessoa;
    private $titular_cadpessoa;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('numero');
        parent::addAttribute('agencia');
        parent::addAttribute('banco');
        parent::addAttribute('conta');
        parent::addAttribute('datalancamento');
        parent::addAttribute('dataemissao');
        parent::addAttribute('datavencimento');
        parent::addAttribute('titular');
        parent::addAttribute('titularcpfcnpj');
        parent::addAttribute('titulartelefone');
        parent::addAttribute('titular_cadpessoa_id');
        parent::addAttribute('cadsituacaocheque_id');
        parent::addAttribute('cadcaixacontacorrente_id');
        parent::addAttribute('portador_cadpessoa_id');
        parent::addAttribute('observacoes');
        parent::addAttribute('portador');
    }

    
    /**
     * Method set_cadcaixacontacorrente
     * Sample of usage: $movcheque->cadcaixacontacorrente = $object;
     * @param $object Instance of Cadcaixacontacorrente
     */
    public function set_cadcaixacontacorrente(Cadcaixacontacorrente $object)
    {
        $this->cadcaixacontacorrente = $object;
        $this->cadcaixacontacorrente_id = $object->id;
    }
    
    /**
     * Method get_cadcaixacontacorrente
     * Sample of usage: $movcheque->cadcaixacontacorrente->attribute;
     * @returns Cadcaixacontacorrente instance
     */
    public function get_cadcaixacontacorrente()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrente))
            $this->cadcaixacontacorrente = new Cadcaixacontacorrente($this->cadcaixacontacorrente_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrente;
    }
    
    
    /**
     * Method set_cadsituacaocheque
     * Sample of usage: $movcheque->cadsituacaocheque = $object;
     * @param $object Instance of Cadsituacaocheque
     */
    public function set_cadsituacaocheque(Cadsituacaocheque $object)
    {
        $this->cadsituacaocheque = $object;
        $this->cadsituacaocheque_id = $object->id;
    }
    
    /**
     * Method get_cadsituacaocheque
     * Sample of usage: $movcheque->cadsituacaocheque->attribute;
     * @returns Cadsituacaocheque instance
     */
    public function get_cadsituacaocheque()
    {
        // loads the associated object
        if (empty($this->cadsituacaocheque))
            $this->cadsituacaocheque = new Cadsituacaocheque($this->cadsituacaocheque_id);
    
        // returns the associated object
        return $this->cadsituacaocheque;
    }
    
    
    /**
     * Method set_titular_cadpessoa
     * Sample of usage: $movcheque->titular_cadpessoa = $object;
     * @param $object Instance of Cadpessoa
     */
    public function set_titular_cadpessoa(Cadpessoa $object)
    {
        $this->titular_cadpessoa = $object;
        $this->titular_cadpessoa_id = $object->id;
    }
    
    /**
     * Method get_titular_cadpessoa
     * Sample of usage: $movcheque->titular_cadpessoa->attribute;
     * @returns titular_Cadpessoa instance
     */
    public function get_titular_cadpessoa()
    {
        // loads the associated object
        if (empty($this->titular_cadpessoa))
            $this->titular_cadpessoa = new Cadpessoa($this->titular_cadpessoa_id);
    
        // returns the associated object
        return $this->titular_cadpessoa;
    }
    
    /**
     * Method set_portador_cadpessoa
     * Sample of usage: $movcheque->portador_cadpessoa = $object;
     * @param $object Instance of Cadpessoa
     */
    public function set_portador_cadpessoa(Cadpessoa $object)
    {
        $this->portador_cadpessoa = $object;
        $this->portador_cadpessoa_id = $object->id;
    }
    
    /**
     * Method get_portador_cadpessoa
     * Sample of usage: $movcheque->portador_cadpessoa->attribute;
     * @returns portador_Cadpessoa instance
     */
    public function get_portador_cadpessoa()
    {
        // loads the associated object
        if (empty($this->portador_cadpessoa))
            $this->portador_cadpessoa = new Cadpessoa($this->portador_cadpessoa_id);
    
        // returns the associated object
        return $this->portador_cadpessoa;
    }    
    
}
