<?php
/**
 * SystemUserCadalmoxarifado Active Record
 * @author  <your-name-here>
 */
class SystemUserCadalmoxarifado extends TRecord
{
    const TABLENAME = 'system_user_cadalmoxarifado';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadalmoxarifado;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_user_id');
        parent::addAttribute('cadalmoxarifado_id');
    }

    
    /**
     * Method set_cadalmoxarifado
     * Sample of usage: $system_user_cadalmoxarifado->cadalmoxarifado = $object;
     * @param $object Instance of Cadalmoxarifado
     */
    public function set_cadalmoxarifado(Cadalmoxarifado $object)
    {
        $this->cadalmoxarifado = $object;
        $this->cadalmoxarifado_id = $object->id;
    }
    
    /**
     * Method get_cadalmoxarifado
     * Sample of usage: $system_user_cadalmoxarifado->cadalmoxarifado->attribute;
     * @returns Cadalmoxarifado instance
     */
    public function get_cadalmoxarifado()
    {
        // loads the associated object
        if (empty($this->cadalmoxarifado))
            $this->cadalmoxarifado = new Cadalmoxarifado($this->cadalmoxarifado_id);
    
        // returns the associated object
        return $this->cadalmoxarifado;
    }
    


}
