<?php
/**
 * Cadgrupoproduto Active Record
 * @author  <your-name-here>
 */
class Cadgrupoproduto extends TRecord
{
    const TABLENAME = 'cadgrupoproduto';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadsubgrupoprodutos;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('grupoproduto');
        parent::addAttribute('ativo');
        parent::addAttribute('comissao');
        parent::addAttribute('descontomaximo');
    }

    
    /**
     * Method addCadsubgrupoproduto
     * Add a Cadsubgrupoproduto to the Cadgrupoproduto
     * @param $object Instance of Cadsubgrupoproduto
     */
    public function addCadsubgrupoproduto(Cadsubgrupoproduto $object)
    {
        $this->cadsubgrupoprodutos[] = $object;
    }
    
    /**
     * Method getCadsubgrupoprodutos
     * Return the Cadgrupoproduto' Cadsubgrupoproduto's
     * @return Collection of Cadsubgrupoproduto
     */
    public function getCadsubgrupoprodutos()
    {
        return $this->cadsubgrupoprodutos;
    }

    /**
     * Reset aggregates
     */
    public function clearParts()
    {
        $this->cadsubgrupoprodutos = array();
    }

    /**
     * Load the object and its aggregates
     * @param $id object ID
     */
    public function load($id)
    {
    
        // load the related Cadsubgrupoproduto objects
        $repository = new TRepository('Cadsubgrupoproduto');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadgrupoproduto_id', '=', $id));
        $this->cadsubgrupoprodutos = $repository->load($criteria);
    
        // load the object itself
        return parent::load($id);
    }

    /**
     * Store the object and its aggregates
     */
    public function store()
    {
        // store the object itself
        parent::store();
    
        // delete the related Cadsubgrupoproduto objects
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadgrupoproduto_id', '=', $this->id));
        $repository = new TRepository('Cadsubgrupoproduto');
        $repository->delete($criteria);
        // store the related Cadsubgrupoproduto objects
        if ($this->cadsubgrupoprodutos)
        {
            foreach ($this->cadsubgrupoprodutos as $cadsubgrupoproduto)
            {
                unset($cadsubgrupoproduto->id);
                $cadsubgrupoproduto->cadgrupoproduto_id = $this->id;
                $cadsubgrupoproduto->store();
            }
        }
    }

    /**
     * Delete the object and its aggregates
     * @param $id object ID
     */
    public function delete($id = NULL)
    {
        $id = isset($id) ? $id : $this->id;
        // delete the related Cadsubgrupoproduto objects
        $repository = new TRepository('Cadsubgrupoproduto');
        $criteria = new TCriteria;
        $criteria->add(new TFilter('cadgrupoproduto_id', '=', $id));
        $repository->delete($criteria);
        
    
        // delete the object itself
        parent::delete($id);
    }


}
