<?php
/**
 * Cadproduto Active Record
 * @author  <your-name-here>
 */
class Cadproduto extends TRecord
{
    const TABLENAME = 'cadproduto';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadgrupoproduto;
    private $cadfabricante;
    private $cadsubgrupoproduto;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('produto');
        parent::addAttribute('unidade');
        parent::addAttribute('codbarras');
        parent::addAttribute('reffabricante');
        parent::addAttribute('referencia');
        parent::addAttribute('tipo');
        parent::addAttribute('origem');
        parent::addAttribute('ncm');
        parent::addAttribute('ncmex');
        parent::addAttribute('cest');
        parent::addAttribute('datacadastro');
        parent::addAttribute('custocompra');
        parent::addAttribute('customedio');
        parent::addAttribute('custofinal');
        parent::addAttribute('precovenda');
        parent::addAttribute('margemlucro');
        parent::addAttribute('pesobruto');
        parent::addAttribute('pesoliquido');
        parent::addAttribute('comissao');
        parent::addAttribute('descontomaximo');
        parent::addAttribute('estoquemaximo');
        parent::addAttribute('estoqueminimo');
        parent::addAttribute('usagrade');
        parent::addAttribute('usaserial');
        parent::addAttribute('balancavalidade');
        parent::addAttribute('balancatecla');
        parent::addAttribute('balancaexporta');
        parent::addAttribute('aplicacao');
        parent::addAttribute('pathimagem');
        parent::addAttribute('cadgrupoproduto_id');
        parent::addAttribute('cadfabricante_id');
        parent::addAttribute('cadgrade_id');
        parent::addAttribute('cadsubgrupoproduto_id');
        parent::addAttribute('ativo');
        parent::addAttribute('produtoservico');
    }

    
    /**
     * Method set_cadgrupoproduto
     * Sample of usage: $cadproduto->cadgrupoproduto = $object;
     * @param $object Instance of Cadgrupoproduto
     */
    public function set_cadgrupoproduto(Cadgrupoproduto $object)
    {
        $this->cadgrupoproduto = $object;
        $this->cadgrupoproduto_id = $object->id;
    }
    
    /**
     * Method get_cadgrupoproduto
     * Sample of usage: $cadproduto->cadgrupoproduto->attribute;
     * @returns Cadgrupoproduto instance
     */
    public function get_cadgrupoproduto()
    {
        // loads the associated object
        if (empty($this->cadgrupoproduto))
            $this->cadgrupoproduto = new Cadgrupoproduto($this->cadgrupoproduto_id);
    
        // returns the associated object
        return $this->cadgrupoproduto;
    }
    
    
    /**
     * Method set_cadfabricante
     * Sample of usage: $cadproduto->cadfabricante = $object;
     * @param $object Instance of Cadfabricante
     */
    public function set_cadfabricante(Cadfabricante $object)
    {
        $this->cadfabricante = $object;
        $this->cadfabricante_id = $object->id;
    }
    
    /**
     * Method get_cadfabricante
     * Sample of usage: $cadproduto->cadfabricante->attribute;
     * @returns Cadfabricante instance
     */
    public function get_cadfabricante()
    {
        // loads the associated object
        if (empty($this->cadfabricante))
            $this->cadfabricante = new Cadfabricante($this->cadfabricante_id);
    
        // returns the associated object
        return $this->cadfabricante;
    }
    
    
    /**
     * Method set_cadsubgrupoproduto
     * Sample of usage: $cadproduto->cadsubgrupoproduto = $object;
     * @param $object Instance of Cadsubgrupoproduto
     */
    public function set_cadsubgrupoproduto(Cadsubgrupoproduto $object)
    {
        $this->cadsubgrupoproduto = $object;
        $this->cadsubgrupoproduto_id = $object->id;
    }
    
    /**
     * Method get_cadsubgrupoproduto
     * Sample of usage: $cadproduto->cadsubgrupoproduto->attribute;
     * @returns Cadsubgrupoproduto instance
     */
    public function get_cadsubgrupoproduto()
    {
        // loads the associated object
        if (empty($this->cadsubgrupoproduto))
            $this->cadsubgrupoproduto = new Cadsubgrupoproduto($this->cadsubgrupoproduto_id);
    
        // returns the associated object
        return $this->cadsubgrupoproduto;
    }
    


}
