<?php
/**
 * Movimentoitem Active Record
 * @author  <your-name-here>
 */
class Movimentoitem extends TRecord
{
    const TABLENAME = 'movimentoitem';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadproduto;
    private $cadnaturezaoperacao;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('item');
        parent::addAttribute('movimento_id');
        parent::addAttribute('codproduto_fornecedor');
        parent::addAttribute('cadproduto_id');
        parent::addAttribute('codbarra');
        parent::addAttribute('produto');
        parent::addAttribute('produtoservico');
        parent::addAttribute('qtde_embalagem');
        parent::addAttribute('qtde');
        parent::addAttribute('qtde_faturada');
        parent::addAttribute('qtde_devolvida');
        parent::addAttribute('qtde_entregue');
        parent::addAttribute('qtde_temporaria');
        parent::addAttribute('qtde_informada');
        parent::addAttribute('unitario');
        parent::addAttribute('unitario_embalagem');
        parent::addAttribute('unitario_praticado');
        parent::addAttribute('desconto');
        parent::addAttribute('margem_desconto');
        parent::addAttribute('subtotal');
        parent::addAttribute('total');
        parent::addAttribute('cadnaturezaoperacao_id');
        parent::addAttribute('cst_ipi');
        parent::addAttribute('ipi_aliquota');
        parent::addAttribute('ipi_cenq');
        parent::addAttribute('ipi_base');
        parent::addAttribute('ipi_valor');
        parent::addAttribute('cst');
        parent::addAttribute('csosn');
        parent::addAttribute('icms_aliquota');
        parent::addAttribute('icms_base');
        parent::addAttribute('icms_reducao');
        parent::addAttribute('icms_valor');
        parent::addAttribute('icms_modbc');
        parent::addAttribute('icmsst_aliquota');
        parent::addAttribute('icmsst_mva');
        parent::addAttribute('icmsst_reducao');
        parent::addAttribute('icmsst_base');
        parent::addAttribute('icmsst_valor');
        parent::addAttribute('icmsst_modbc');
        parent::addAttribute('peso_bruto');
        parent::addAttribute('peso_liquido');
        parent::addAttribute('cst_pis');
        parent::addAttribute('pis_aliquota');
        parent::addAttribute('pis_base');
        parent::addAttribute('pis_valor');
        parent::addAttribute('cst_cofins');
        parent::addAttribute('cofins_aliquota');
        parent::addAttribute('cofins_base');
        parent::addAttribute('cofins_valor');
        parent::addAttribute('altera_item');
        parent::addAttribute('complemento');
        parent::addAttribute('unidade');
        parent::addAttribute('unidade_embalagem');
        parent::addAttribute('outras');
        parent::addAttribute('frete');
        parent::addAttribute('seguro');
        parent::addAttribute('situacao');
        parent::addAttribute('tipo_fator');
        parent::addAttribute('fator');
        parent::addAttribute('cfop_entrada');
        parent::addAttribute('cst_entrada');
        parent::addAttribute('csosn_entrada');
        parent::addAttribute('cst_ipi_entrada');
        parent::addAttribute('cst_pis_entrada');
        parent::addAttribute('cst_cofins_entrada');
        parent::addAttribute('custocompra');
        parent::addAttribute('customedio');
        parent::addAttribute('custofinal');
        parent::addAttribute('precocusto');
        parent::addAttribute('precocusto_atual');
        parent::addAttribute('precovenda_lucro');
        parent::addAttribute('precovenda');
        parent::addAttribute('precovenda_atual');
        parent::addAttribute('altera_venda');
        parent::addAttribute('altera_custo');
    }

    
    /**
     * Method set_cadproduto
     * Sample of usage: $movimentoitem->cadproduto = $object;
     * @param $object Instance of Cadproduto
     */
    public function set_cadproduto(Cadproduto $object)
    {
        $this->cadproduto = $object;
        $this->cadproduto_id = $object->id;
    }
    
    /**
     * Method get_cadproduto
     * Sample of usage: $movimentoitem->cadproduto->attribute;
     * @returns Cadproduto instance
     */
    public function get_cadproduto()
    {
        // loads the associated object
        if (empty($this->cadproduto))
            $this->cadproduto = new Cadproduto($this->cadproduto_id);
    
        // returns the associated object
        return $this->cadproduto;
    }
    
    
    /**
     * Method set_cadnaturezaoperacao
     * Sample of usage: $movimentoitem->cadnaturezaoperacao = $object;
     * @param $object Instance of Cadnaturezaoperacao
     */
    public function set_cadnaturezaoperacao(Cadnaturezaoperacao $object)
    {
        $this->cadnaturezaoperacao = $object;
        $this->cadnaturezaoperacao_id = $object->id;
    }
    
    /**
     * Method get_cadnaturezaoperacao
     * Sample of usage: $movimentoitem->cadnaturezaoperacao->attribute;
     * @returns Cadnaturezaoperacao instance
     */
    public function get_cadnaturezaoperacao()
    {
        // loads the associated object
        if (empty($this->cadnaturezaoperacao))
            $this->cadnaturezaoperacao = new Cadnaturezaoperacao($this->cadnaturezaoperacao_id);
    
        // returns the associated object
        return $this->cadnaturezaoperacao;
    }
    


}
