<?php
/**
 * CadcidadeFormView Form
 * @author  <your name here>
 */
class CadcidadeFormView extends TPage
{
    /**
     * Show data
     */
    public function onEdit( $param )
    {
        try
        {
            // convert parameter to object
            $data = (object) $param;
            
            // load the html template
            $html = new THtmlRenderer('app/resources/cadcidadeformview.html');
            
            // load CSS styles
            parent::include_css('app/resources/styles.css');
            
            TTransaction::open('goldnotas');
            if (isset($data->id))
            {
                // load customer identified in the form
                $object = Cadcidade::find( $data->id );
                if ($object)
                {
                    // create one array with the customer data
                    $array_object = $object->toArray();
                    
                    // replace variables from the main section with the object data
                    $html->enableSection('main',  $array_object);
                }
                else
                {
                    throw new Exception('Cadcidade not found');
                }
            }
            
            TTransaction::close();
            
            // vertical box container
            $container = new TVBox;
            // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
            $container->add($html);
            parent::add($container);
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }
    }
}
