<?php
/**
 * CadpessoaForm Form
 * @author  <your name here>
 */
class CadpessoaForm extends TPage
{
    protected $form; // form
    //protected $tipocadastro;
    //public $labelcpfcnpj;
    /**
     * Form constructor
     * @param $param Request
     */
    public function __construct( $param )
    {
        //$tipocadastro = $param['tipopessoa']??'J';
        //echo $tipocadastro . "</br>";
        parent::__construct();   
        parent::include_js('app/lib/include/application.js');
        parent::include_js('app/lib/include/app_sctipt_tabenter.js');
        TPage::include_js('app/resources/eventosjs.js');      
        // creates the form
        $this->form = new BootstrapFormBuilder('form_Cadpessoa');                       
        $this->form->appendPage('Principal');              
        TTransaction::open('goldnotas');
        $idpessoa = $param['id']??'';
        if ( !empty($idpessoa))
        {
            TSession::setValue('idpessoa',$idpessoa);
            $objeto = new Cadpessoa($idpessoa);
            $tipocadastro = $objeto->tipopessoa;
        }
        else
        {
            $tipocadastro = $param['tipocadastro']??'F';        
        }
        TTransaction::close();
        if ($tipocadastro == 'F') {$this->form->setFormTitle('Pessoa Física');}
        else {$this->form->setFormTitle('Pessoa Jurídica');}
        // create the form fields
        $id = new TEntry('id');
        $pessoa = new TEntry('pessoa');
        $fantasia = new TEntry('fantasia');        
        $tipopessoa = new TCombo('tipopessoa');
        //$tipopessoa = new THidden('tipopessoa');
        $dtcadastro = new TDate('dtcadastro');
        $bloqueado = new TCombo('bloqueado');
        $ecliente = new TCheckGroup('ecliente');
        $efornecedor = new TCheckGroup('efornecedor');
        $efuncionario = new TCheckGroup('efuncionario');
        $etransportador = new TCheckGroup('etransportador');
        $econtador = new TCheckGroup('econtador');
        $econvenio = new TCheckGroup('econvenio');
        $evendedor = new TCheckGroup('evendedor');
        $cpfcnpj = new TEntry('cpfcnpj');
        $rginscricaoestadual = new TEntry('rginscricaoestadual');
        $inscricaomunicipal = new TEntry('inscricaomunicipal');
        $issqnretido = new TCheckGroup('issqnretido');
        $rpr = new TEntry('rpr');
        $cnae = new TEntry('cnae');
        $crt = new TCombo('crt');
        $tipocliente = new TCombo('tipocliente');
        $telefone1 = new TEntry('telefone1');
        $telefone2 = new TEntry('telefone2');
        $telefone3 = new TEntry('telefone3');
        $telefone4 = new TEntry('telefone4');
        $contato = new TEntry('contato');
        $email = new TEntry('email');
        $limitecredito = new TEntry('limitecredito');
        $atrazomaximo = new TEntry('atrazomaximo');
        $dtconsultaspc = new TDate('dtconsultaspc');
        $dtregistrospc = new TDate('dtregistrospc');
        $dtreaberturaspc = new TDate('dtreaberturaspc');
        $estadocivil = new TCombo('estadocivil');
        $naturalidade = new TEntry('naturalidade');
        $dtnascimento = new TDate('dtnascimento');
        $sexo = new TCombo('sexo');
        $empresatrabalho = new TEntry('empresatrabalho');
        $telefonetrabalho = new TEntry('telefonetrabalho');
        $cargofuncaotrabalho = new TEntry('cargofuncaotrabalho');
        $dtadmissaotrabalho = new TDate('dtadmissaotrabalho');
        $salariotrabalho = new TEntry('salariotrabalho');
        $rendafamiliar = new TEntry('rendafamiliar');
        $nomeconjugue = new TEntry('nomeconjugue');
        $telefoneconjugue = new TEntry('telefoneconjugue');
        $nomepai = new TEntry('nomepai');
        $nomemae = new TEntry('nomemae');
        $vendedor_cadpessoa_id = new TEntry('vendedor_cadpessoa_id');
        $convenio_cadpessoa_id = new TEntry('convenio_cadpessoa_id');
        $cadregiao_id = new TDBCombo('cadregiao_id', 'goldnotas', 'Cadregiao', 'id', '{id} - {regiao}');
        $endprinc_logradouro = new TEntry('endprinc_logradouro');
        $endprinc_numero = new TEntry('endprinc_numero');
        $endprinc_bairro = new TEntry('endprinc_bairro');
        $endprinc_complemento = new TEntry('endprinc_complemento');
        //$endprinc_cadcidade_id = new TEntry('endprinc_cadcidade_id');
        $endprinc_cadcidade_id = new TDBCombo('endprinc_cadcidade_id', 'goldnotas', 'Cadcidade', 'id', '{id} - {cidade} - {uf}','cidade');
        $endprinc_cep = new TEntry('endprinc_cep');
        $observacoesvenda = new TText('observacoesvenda');
        $observacoesdiversas = new TText('observacoesdiversas');
        $dtadmissaofuncionario = new TDate('dtadmissaofuncionario');
        $dtdemissaofuncionario = new TDate('dtdemissaofuncionario');
        $produtocomissao = new TEntry('produtocomissao');
        $servicocomissao = new TEntry('servicocomissao');
        $ativo = new TCheckGroup('ativo');        
        $contribuinteicms = new TCombo('contribuinteicms');
        $atrasomaximo = new TEntry('atrasomaximo');        
        $cnh = new TEntry('cnh');
        $dtvencimentocnh = new TDate('dtvencimentocnh');
        $numeroregistrocooperativa = new TEntry('numeroregistrocooperativa');              
        
        $frame_classpessoa = new TFrame(NULL, 160);     
        //$labelcpfcnpj = "<label id='lbcpfcnpj'>CPF</label>";//new TLabel('CPF/CNPJ'); 
        if ($tipocadastro != 'J')
        {
            //$this->form->appendPage('Dados Pessoais');
            $cpfcnpj->SetMask('999.999.999-99');
            $labelcpfcnpj = new TLabel('CPF');
            $labelcpfcnpj->id = 'lbcpfcnpj';
            $labelrgie = new TLabel('RG');
            $labelrgie->id = 'lbrgie';             
            $lblfantasia = 'Apelido'; 
            $tipopessoaitens=array();
            $tipopessoaitens['F'] = 'Física';
            //$tipopessoaitens['J'] = 'Jurídica';
            $tipopessoaitens['P'] = 'Produtor Rural';
            $tipopessoa->addItems($tipopessoaitens);
            $tipopessoa->setValue($tipocadastro);
            $tipopessoa->setSize('100%');                                   
        }  
        else
        {
            $cpfcnpj->SetMask('99.999.999/9999-99');       
            $labelcpfcnpj = new TLabel('CNPJ');
            $labelcpfcnpj->id = 'lbcpfcnpj';
            $labelrgie = new TLabel('Insc. Estadual');
            $labelrgie->id = 'lbrgie';  
            //$tipopessoa = $tipocadastro;   
            $lblfantasia = 'Fantasia'; 
            $tipopessoaitens=array();
            $tipopessoaitens['J'] = 'Jurídica';
            $tipopessoa->addItems($tipopessoaitens);
            $tipopessoa->setValue($tipocadastro);
            $tipopessoa->setSize('100%');                                
        }                                         
        $id->setSize('30%');  
        $pessoa->setSize('100%');
        $fantasia->setSize('100%');        

        //$tipopessoa->addItems(s7sdiversos::listtipopessoa());
        //$tipopessoa->setValue('F');
        //$tipopessoa->setSize('100%');
       
        $rginscricaoestadual->setSize('100%');
        if ($tipocadastro == 'J') { $inscricaomunicipal->setSize('70%'); }
        else {$inscricaomunicipal->setSize('100%');}

        $onChangeTipoPessoa = new TAction(array($this, 'onChangeTipoPessoa'));
        $tipopessoa->setChangeAction($onChangeTipoPessoa);        

        $cpfcnpj->setSize('100%');
        //$cpfcnpj->SetMask('999.999.999-99');                
        $crt->setSize('100%'); 
        $crt->addItems(s7sdiversos::listcrt());
        $cnae->setSize('100%');        
        $rpr->setSize('100%');
        
        $tipocliente->setSize('100%');
        $tipocliente->addItems(s7sdiversos::listtipocliente());
        
        
        $items=array();
        $items['1'] = 'Sim';
        $items['9'] = 'Não';        
        if ($tipocadastro == 'J')
        {
            $items['2'] = 'Isento';
        }         
        $contribuinteicms->setSize('100%');
        $contribuinteicms->addItems($items);
        
        $cadregiao_id->setSize('100%');
        $cadregiao_id->enableSearch();    
        
        $email->setSize('100%');
        $contato->setSize('100%');               
        
        $telefone1->setSize('100%');             
        $telefone1->setMaxLength(20);
        $telefone2->setSize('100%'); 
        $telefone2->setMaxLength(20);                   
        $telefone3->setSize('100%');          
        $telefone3->setMaxLength(20);                
        $telefone4->setSize('100%');             
        $telefone4->setMaxLength(20);
        
        //endereco
        
        /*       
        $endprinc_numero = new TEntry('endprinc_numero');
        $endprinc_bairro = new TEntry('endprinc_bairro');
        $endprinc_complemento = new TEntry('endprinc_complemento');
        $endprinc_cadcidade_id = new TEntry('endprinc_cadcidade_id');
        $endprinc_cep = new TEntry('endprinc_cep');            
        */
        
        //BootstrapFormBuilder::showField('form_CfcDocumentos', 'cfc_alunos_id');
        //BootstrapFormBuilder::hideField('form_CfcDocumentos', 'cfc_funcionarios_id');

        $dtcadastro->setSize('30%');
        $dtcadastro->setMask('dd/mm/yyyy');
        $dtcadastro->setDatabaseMask('yyyy-mm-dd');        
        $dtcadastro->setEditable(False);
        
        $endprinc_logradouro->setSize('100%');        
        $endprinc_numero->setSize('100%');
        $endprinc_cep->setSize('100%');
        $endprinc_cep->setMask('99.999-999');
        $endprinc_complemento->setSize('100%');
        $endprinc_bairro->setSize('100%'); 
        $endprinc_cadcidade_id->setSize('100%');                  
        $endprinc_cadcidade_id->enableSearch();
        
        $limitecredito->setSize('100%');
        $limitecredito->setNumericMask(2, ',', '.', true);
        
        $atrazomaximo->setSize('100%');
        $atrasomaximo->setProperty('style','text-align:right');
        $atrazomaximo->setMask('9999999999');
        $atrasomaximo->setInputType('number');
        
        $dtconsultaspc->setSize('100%');
        $dtconsultaspc->setMask('dd/mm/yyyy');
        $dtconsultaspc->setDatabaseMask('yyyy-mm-dd');
        $dtregistrospc->setSize('100%');
        $dtregistrospc->setMask('dd/mm/yyyy');
        $dtregistrospc->setDatabaseMask('yyyy-mm-dd');
        $dtreaberturaspc->setSize('100%');
        $dtreaberturaspc->setMask('dd/mm/yyyy');
        $dtreaberturaspc->setDatabaseMask('yyyy-mm-dd');        
        
        //dados pessoais
        $estadocivil->setSize('100%');
        $estadocivil->addItems(s7sdiversos::listestadocivil());
        $naturalidade->setSize('100%');
        $dtnascimento->setSize('100%');
        $dtnascimento->setMask('dd/mm/yyyy');
        $dtnascimento->setDatabaseMask('yyyy-mm-dd');        
        $sexo->setSize('100%');
        $sexo->addItems(s7sdiversos::listsexopessoa());
        $empresatrabalho->setSize('100%');
        $telefonetrabalho->setSize('100%');
        $telefonetrabalho->setMaxLength(20);       
        $cargofuncaotrabalho->setSize('100%');         
        $dtadmissaotrabalho->setSize('100%');
        $dtadmissaotrabalho->setMask('dd/mm/yyyy');
        $dtadmissaotrabalho->setDatabaseMask('yyyy-mm-dd');        
        $salariotrabalho->setSize('100%');
        $salariotrabalho->setNumericMask(2, ',', '.', true);
        $rendafamiliar->setSize('100%');
        $rendafamiliar->setNumericMask(2, ',', '.', true);
        $nomeconjugue->setSize('100%');
        $telefoneconjugue->setSize('100%');
        $telefoneconjugue->setMaxLength(20);      
        $nomepai->setSize('100%');
        $nomemae->setSize('100%');  
        $cnh->setSize('100%');
        $dtvencimentocnh->setSize('100%');
        $dtvencimentocnh->setMask('dd/mm/yyyy');
        $dtvencimentocnh->setDatabaseMask('yyyy-mm-dd');      

        $ativo->setLayout('horizontal');
        $items = array();
        $items['S'] ='Ativo'; 
        $ativo->addItems($items);        
        
        $ecliente->setLayout('horizontal');
        $items = array();
        $items['S'] ='Cliente'; 
        $ecliente->addItems($items); 

        $efornecedor->setLayout('horizontal');
        $items = array();
        $items['S'] ='Fornecedor'; 
        $efornecedor->addItems($items);                     
        
        $etransportador->setLayout('horizontal');
        $items = array();
        $items['S'] ='Transportadora'; 
        $etransportador->addItems($items);
        
        $econtador->setLayout('horizontal');
        $items = array();
        $items['S'] ='Contador'; 
        $econtador->addItems($items);
        
        $econvenio->setLayout('horizontal');
        $items = array();
        $items['S'] ='Convênio'; 
        $econvenio->addItems($items); 

        $efuncionario->setLayout('horizontal');
        $items = array();
        $items['S'] ='Funcionário'; 
        $efuncionario->addItems($items);
        
        $evendedor->setLayout('horizontal');
        $items = array();
        $items['S'] ='Vendedor'; 
        $evendedor->addItems($items);  
        
        $issqnretido->setLayout('horizontal');
        $items = array();
        $items['S'] ='ISSQN Retido'; 
        $issqnretido->addItems($items);   
        
        
                     
        
        $labelprincipal = new TLabel('Principal', '#7D78B6', 12, 'b');
        $labelprincipal->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelprincipal->setSize('100%');                     
        
        //$tipopessoa = $tipocadastro;
        //echo $tipopessoa . " </br>";
        //$this->form->addField($tipopessoa);
        $this->form->addContent( [$labelprincipal] );        
        $this->form->addFields( [new TLabel('Código')], [$id, $ativo], [new TLabel('Data Cadastro')], [$dtcadastro]);        
        $this->form->addFields( [new TLabel('Nome')],[$pessoa]);
        $this->form->addFields( [new TLabel('Fantasia')],[$fantasia],[new TLabel('Tipo pessoa')],[$tipopessoa]);
        //$this->form->addFields( [new TLabel($lblfantasia)],[$fantasia]);
        //$this->form->addFields([$tipopessoa]);
        //$this->form->addFields( [new TLabel($lblfantasia)],[$fantasia]);
        $this->form->addFields( [$labelcpfcnpj], [$cpfcnpj],[$labelrgie],[$rginscricaoestadual]);        
        if ($tipocadastro == 'J' )
        {
            $this->form->addFields( [new TLabel('Insc. Municipal')],[$inscricaomunicipal,$issqnretido],[null]);
            $this->form->addFields( [new TLabel('CRT')],[$crt],[new TLabel('CNAE')],[$cnae]);
        }
        else
        {
            $this->form->addFields( [new TLabel('Insc. Municipal')],[$inscricaomunicipal],[new TLabel('R.Produtor Rural')],[$rpr]);
            $issqnretido->setValue('N');
        }
        $this->form->addFields( [new TLabel('Tipo Cliente')],[$tipocliente],[new TLabel('Contruinte ICMS')],[$contribuinteicms]);        
        
        $labelcontato = new TLabel('Contato', '#7D78B6', 12, 'b');
        $labelcontato->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelcontato->setSize('100%');

        $labelendereco = new TLabel('Endereço', '#7D78B6', 12, 'b');
        $labelendereco->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $labelendereco->setSize('100%');
        $this->form->addContent( [$labelendereco] );
        $this->form->addFields([new TLabel('Endereço')],[$endprinc_logradouro]);
        $this->form->addFields([new TLabel('Número')],[$endprinc_numero],[new TLabel('Cep')],[$endprinc_cep]);
        $this->form->addFields([new TLabel('Complemento')],[$endprinc_complemento],[new TLabel('bairro')],[$endprinc_bairro]);
        $this->form->addFields([new TLabel('Região')],[$cadregiao_id],[new TLabel('Cidade')],[$endprinc_cadcidade_id]);                     
        $this->form->addContent( [$labelcontato] );
        $this->form->addFields( [new TLabel('Contato/Responsável')],[$contato], [new TLabel('E-mail')],[$email]);        
        $this->form->addFields( [new TLabel('Telefone 1')],[$telefone1],[new TLabel('Telefone 2')],[$telefone2]);
        $this->form->addFields( [new TLabel('Telefone 3')],[$telefone3],[new TLabel('Telefone 4')],[$telefone4]);               
        //$this->form->addContent( [$frame_classpessoa] );    
        $this->form->appendPage('Crediário');    
        $label1 = new TLabel('Crediário', '#7D78B6', 12, 'b');
        $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $label1->setSize('100%');                     
        $this->form->addContent( [$label1] );
        $this->form->addFields([new TLabel('Limite crédito')],[$limitecredito],[new TLabel('Carência dias')],[$atrasomaximo]);                    
        
        $this->form->addFields([new TLabel('Consulta SPC')],[$dtconsultaspc],[new TLabel('Inclusão SPC')],[$dtregistrospc]);
        $this->form->addFields([new TLabel('Reabertura SPC')],[$dtreaberturaspc],[null],[null]); 
        
        if ($tipocadastro == 'F')
        {
            $this->form->appendPage('Dados Pessoais');
            $label1 = new TLabel('Informações pessoais', '#7D78B6', 12, 'b');
            $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
            $label1->setSize('100%');                     
            $this->form->addContent( [$label1] );            
            $this->form->addFields([new TLabel('Sexo')],[$sexo],[new TLabel('Data Nascimento')],[$dtnascimento],[new TLabel('Naturalidade')],[$naturalidade]);
            $this->form->addFields([new TLabel('Nome Pai')],[$nomepai],[new TLabel('Nome Mão')],[$nomemae]);
            $this->form->addFields([new TLabel('Estado civil')],[$estadocivil],[new TLabel('Nome Conjugue')],[$nomeconjugue]);
            $this->form->addFields([new TLabel('Telefone Conjugue')],[$telefoneconjugue],[new TLabel('Renda Familiar')],[$rendafamiliar]);
            $this->form->addFields([new TLabel('CNH')], [$cnh], [new TLabel('Vencimento CNH')], [$dtvencimentocnh]);
                        
            $label1 = new TLabel('Dados Profissionais', '#7D78B6', 12, 'b');
            $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
            $label1->setSize('100%');                     
            $this->form->addContent( [$label1] );             
            $this->form->addFields([new TLabel('Empresa')],[$empresatrabalho],[new TLabel('Telefone')],[$telefonetrabalho]);
            $this->form->addFields([new TLabel('Função')],[$cargofuncaotrabalho],[new TLabel('Admissão')],[$dtadmissaotrabalho],[new TLabel('Salário')],[$salariotrabalho]);

        }                
        
        $this->form->appendPage('Classificação');
        //$this->form->addContent( [$frame_classpessoa] );        
        $label1 = new TLabel('Classificação', '#7D78B6', 12, 'b');
        $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
        $label1->setSize('100%');                     
        $this->form->addContent( [$label1] ); 
        $this->form->addFields([$ecliente],[$efornecedor],[$etransportador]);
        $this->form->addFields([$econtador],[$econvenio],[$efuncionario]);
        $this->form->addFields([$evendedor]); 
        
        $id->setEditable(False);                         
        if ( !empty($idpessoa))
        {
            $this->form->appendPage('Imagens');               
            $label1 = new TLabel('Imagens', '#7D78B6', 12, 'b');
            $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
            $label1->setSize('100%');
            $this->form->addContent( [$label1] );    
            // place where the products page will be inserted
            $details_area = new TElement('div');
            $details_area->id = 'CadpessoaCadimagem_area';            
            //$this->form->addContent( [TElement::tag('h4', 'Imagens')] );
            $this->form->addContent( [$details_area] );
    
            // Load SaleDetailForm into details_area
            AdiantiCoreApplication::loadPage('CadpessoaCadimagemForm', 'onEdit', ['register_state'=>'false']);            
            
            $this->form->appendPage('Garimpeiro');               
            $label1 = new TLabel('Dados', '#7D78B6', 12, 'b');
            $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
            $label1->setSize('100%');
            $this->form->addContent( [$label1] );
            $numeroregistrocooperativa->setSize('100%');
            $this->form->addFields([new TLabel('N. Registro Cooperativa')],[$numeroregistrocooperativa]); 
            
            $label1 = new TLabel('Contratos', '#7D78B6', 12, 'b');
            $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
            $label1->setSize('100%');
            $this->form->addContent( [$label1] );    
            // place where the products page will be inserted
            $details_area = new TElement('div');
            $details_area->id = 'CadpessoaCadcontratoplg_area';            
            //$this->form->addContent( [TElement::tag('h4', 'Imagens')] );
            $this->form->addContent( [$details_area] );
    
            // Load SaleDetailForm into details_area
            AdiantiCoreApplication::loadPage('CadpessoaCadcontratoplgForm', 'onEdit', ['register_state'=>'false']);   
            
            //$this->form->appendPage('Fornecedor PLG');                          
            $label1 = new TLabel('PLGS', '#7D78B6', 12, 'b');
            $label1->style='text-align:left;border-bottom:1px solid #c0c0c0;width:100%';  
            $label1->setSize('100%');
            $this->form->addContent( [$label1] );    
            // place where the products page will be inserted
            $details_area = new TElement('div');
            $details_area->id = 'CadpessoaCadplg_area';            
            //$this->form->addContent( [TElement::tag('h4', 'Imagens')] );
            $this->form->addContent( [$details_area] );
    
            // Load SaleDetailForm into details_area
            AdiantiCoreApplication::loadPage('CadpessoaCadplgForm', 'onEdit', ['register_state'=>'false']);                       
            
        }
        /** samples
         $this->form->addQuickFields('Date', array($date1, new TLabel('to'), $date2)); // side by side fields
         $fieldX->addValidation( 'Field X', new TRequiredValidator ); // add validation
         $fieldX->setSize( 100, 40 ); // set size
        **/
         
        // create the form actions
        $this->form->addAction( _t('Save'), new TAction(array($this, 'onSave')), 'far:save');
        //$this->form->addAction( _t('New'), new TAction(array($this, 'onEdit')), 'fa:eraser red');        
        $this->form->addAction( _t('Back to the listing'), new TAction(array('CadpessoaList','onReload')), 'fa:table blue');
        
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 90%';
        $container->add(new TXMLBreadCrumb('menu.xml', 'CadpessoaList'));
        //$container->add(TPanelGroup::pack('Title', $this->form));
        $container->add($this->form);

        $scriptfocus = new TElement('script');
        $scriptfocus->type = 'text/javascript';
        $scriptfocus->add("$('input[name=\"pessoa\"]').focus();"); 
        parent::add($scriptfocus);          
        
        //$table->addRow()->addCell($script);              
        //$('#lbcpfcnpj').html('<label id=\'labelcpfcnpj\'>CNPJ</label>');
        //$('#lbcpfcnpj').html('<label id=\'lbcpfcnpj\'>CPF</label>');
        parent::add($container);
        self::onChangeTipoPessoa(array('tipopessoa'=>$tipocadastro));
    }

    /**
     * Save form data
     * @param $param Request
     */
    public function onSave( $param )
    {
        try
        {
            //TSession::getValue('user_empresa_id'); 
            TTransaction::open('goldnotas'); // open a transaction            
            /**
            // Enable Debug logger for SQL operations inside the transaction
            TTransaction::setLogger(new TLoggerSTD); // standard output
            TTransaction::setLogger(new TLoggerTXT('log.txt')); // file
            **/
            
            $this->form->validate(); // validate form data
           
            $object = new Cadpessoa;  // create an empty object
            $data = $this->form->getData(); // get form data as array
            $object->fromArray( (array) $data); // load the object with data
            //$tipopessoa = $object->tipopessoa;
            //$tipocadastro = TSession::getValue('tipocadastro');
            //echo 'onsave ' . $tipocadastro . "</br>";
            //$object->tipopessoa = $tipocadastro;
            //$data->ecliente
            //$cliente=array();
            //$object->ecliente = implode(',', $objeto->ecliente); 
            //$object->tipopessoa = $this->tipocadastro;
            //echo $this->tipocadastro . "</br>";
            //echo 'On Save ' . $data->tipopessoa . "</br>";

            $ativo = $data->ativo;
            if ( !empty($ativo))
            {
                $object->ativo = 'S';
            }
            else { $object->ativo = 'N'; }

            $cliente = $data->ecliente;
            if ( !empty($cliente))
            {
                $object->ecliente = 'S';
            }
            else { $object->ecliente = 'N'; }
            $fornecedor = $data->efornecedor;
            if ( !empty($fornecedor))
            {
                $object->efornecedor = 'S';
            }
            else { $object->efornecedor = 'N'; }
            
            $transportador = $data->etransportador;
            if ( !empty($transportador))
            {
                $object->etransportador = 'S';
            }
            else { $object->etransportador = 'N'; }            
            
            $contador = $data->econtador;
            //var_dump($contador);
            if ( !empty($contador))
            {
                $object->econtador = 'S';
            }
            else { $object->econtador = 'N'; }      
            $convenio = $data->econvenio;
            //var_dump($convenio);
            if ( !empty($convenio))
            {
                $object->econvenio = 'S';
            }
            else { $object->econvenio = 'N'; }     
            $funcionario = $data->efuncionario;
            if ( !empty($funcionario))
            {
                $object->efuncionario = 'S';
            }
            else { $object->efuncionario = 'N'; } 
            $vendedor = $data->evendedor;
            if ( !empty($vendedor))
            {
                $object->evendedor = 'S';
            }
            else { $object->evendedor = 'N'; }
            if ($object->tipopessoa == 'J')
            {
                $issqnretido = $data->issqnretido;   
                if ( !empty($issqnretido))
                {
                    //echo 'issqn </br>';
                    $object->issqnretido = 'S';
                }
                else { $object->issqnretido = 'N'; }
            }            
            //$tipopessoa = $data->tipopessoa;
            //var_dump($data->tipopessoa);
            /*
            if ( !empty($tipopessoa))
            {
                if ($tipopessoa['0'])
            }
            else { $object->ativo = 'N'; }
            */
            //$object->ativo = 'S';
            //$object->tipopessoa = 1;
            //$object->tipocliente = 1;
            //echo 'Aqui <br>';
            $pessoa_images = TSession::getValue('pessoa_images');
            if ($pessoa_images)
            {
                foreach ($pessoa_images as $imagem_item)
                {
                    $nomeimg = $imagem_item['imagem']; 
                    if ($imagem_item['del'] == 'N')
                    {
                        $item = new CadpessoaCadimagem;
                        $item->descricao = $imagem_item['descricao'];
                        $item->ordem = $imagem_item['ordem'];
                        $nomeimg = $imagem_item['imagem'];
                        $item->id = $imagem_item['id'];
                        if (empty($imagem_item['id']))
                        {                        
                            unset($item->id);
                            $nomeimg = pathinfo($imagem_item['imagem'], PATHINFO_FILENAME);
                            $extimg = pathinfo($imagem_item['imagem'], PATHINFO_EXTENSION);
                            $nomeimg = 'imagespessoas/' .  $nomeimg.'.'.$extimg;                                                                                       
                            if(file_exists($nomeimg))
                            {                                                                    
                                unlink($nomeimg);                                            
                            }
                            rename($imagem_item['imagem'], $nomeimg);                                                
                        } 
                        $item->imagem = $nomeimg;
                        $object->addCadpessoaCadimagem($item);
                    }
                    else
                    {
                        unlink($nomeimg);    
                    }                       
                }  
            }
            
            $pessoa_contratos = TSession::getValue('pessoa_contratos');
            if ($pessoa_contratos)
            {
                foreach ($pessoa_contratos as $contrato_item)
                {
                    //echo var_dump($contrato_item);
                    if ($contrato_item['del'] == 'N')
                    {
                        $itemcontrato = new CadpessoaCadcontratoplg;
                        $itemcontrato->id = $contrato_item['id'];
                        $itemcontrato->contrato_cadpessoa_id = $contrato_item['contrato_cadpessoa_id'];
                        $itemcontrato->dtcadastro = TDate::date2us($contrato_item['dtcadastro']);
                        $itemcontrato->dtemissao = TDate::date2us($contrato_item['dtemissao']);
                        $itemcontrato->dtvencimento = TDate::date2us($contrato_item['dtvencimento']);
                        $itemcontrato->observacoes = $contrato_item['observacoes'];
                        $itemcontrato->numero = $contrato_item['numero']; 
                        $itemcontrato->ativo = $contrato_item['ativo']; 
                        $itemcontrato->cadcontrato_id = $contrato_item['cadcontrato_id'];                      
                        $object->addCadpessoaCadcontratoplg($itemcontrato);                            
                    }   
                }    
            }
                        
            $pessoa_plgs = TSession::getValue('pessoa_plgs');
            if ($pessoa_plgs)
            {
                foreach ($pessoa_plgs as $plg_item)
                {
                    //echo var_dump($contrato_item);
                    if ($plg_item['del'] == 'N')
                    {
                        $itemplg = new CadpessoaCadplg;
                        $itemplg->id = $plg_item['id'];
                        $itemplg->numeroplg = $plg_item['numeroplg'];
                        $itemplg->vencimentoplg = TDate::date2us($plg_item['vencimentoplg']);                        
                        $itemplg->processodnpm = $plg_item['processodnpm'];
                        $itemplg->localidadeaurifera = $plg_item['localidadeaurifera'];
                        $itemplg->regiaoaurifera = $plg_item['regiaoaurifera'];                      
                        $object->addCadpessoaCadplg($itemplg);                            
                    }   
                }    
            }

            $object->store(); // save the object
            //echo 'Depois <br>';
            // get the generated id
            $data->id = $object->id;
            //$param['key'] = $object->id;            
            //$this->onEdit($param);
            $this->form->setData($data); // fill form data
            TTransaction::close(); // close the transaction
            //TTransactionSession::close();
            
            //new TMessage('info', TAdiantiCoreTranslator::translate('Record saved'));
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->form->setData( $this->form->getData() ); // keep form data
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
        
    
    /**
     * Clear form data
     * @param $param Request
     */
    public function onClear( $param )
    {
        $this->form->clear(TRUE);                
    }
    
    /**
     * Load object to form data
     * @param $param Request
     */
    public function onEdit( $param )
    {
        try
        {
            if (isset($param['key']))
            {
                TSession::delValue('pessoa_contratos');
                TSession::delValue('pessoa_contratos_loaded');            
                TSession::delValue('pessoa_contratos_count');
                TSession::delValue('pessoa_images');
                TSession::delValue('pessoa_images_loaded');            
                TSession::delValue('pessoa_images_count');                                
                $key = $param['key'];  // get the parameter $key
                TTransaction::open('goldnotas'); // open a transaction
                $object = new Cadpessoa($key); // instantiates the Active Record
                $this->form->setData($object); // fill the form
                
                $obj = new StdClass;
                if ($object->ativo == 'S')
                {
                    $obj->ativo = 'S';
                } 
                if ($object->ecliente == 'S')
                {
                    $obj->ecliente = 'S';
                }  
                if ($object->efornecedor == 'S')
                {
                    $obj->efornecedor = 'S';
                }                
                if ($object->econtador == 'S')
                {
                    $obj->econtador = 'S';
                }                  
                if ($object->econvenio == 'S')
                {
                    $obj->econvenio = 'S';
                }                  
                if ($object->etransportador == 'S')
                {
                    $obj->etransportador = 'S';
                }   
                if ($object->efuncionario == 'S')
                {
                    $obj->efuncionario = 'S';
                }                     
                if ($object->evendedor == 'S')
                {
                    $obj->evendedor = 'S';
                }      
                if ($object->issqnretido == 'S')
                {
                    $obj->issqnretido = 'S';
                }                                                 
                TForm::sendData('form_Cadpessoa', $obj);                              
                
                TTransaction::close(); // close the transaction
            }
            else
            {                
                $this->form->clear(TRUE);
                $obj = new StdClass;
                $obj->ativo = 'S'; 
                $obj->dtcadastro = TDate::date2br(date("Y-m-d"));
                //$this->form->setData($obj);
                //Hdebug::debug($obj->dtcadastro);
                //$obj->tipopessoa = 'F';      
                TForm::sendData('form_Cadpessoa', $obj);                
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
	public static function onChangeTipoPessoa($param)
	{ 	//echo 'onChangeTipoPessoa' . $param['tipopessoa'] . ' <br>'; 
	    if ($param['tipopessoa'] == 'P') 
	    {	           
	        TEntry::enableField('form_Cadpessoa', 'rpr');    
	    }
	    else
	    {	        
	        TEntry::disableField('form_Cadpessoa', 'rpr'); 
	    }	
	    if ($param['tipopessoa'] == 'F' ) 
	    {
            $options = array();
            $options['1'] = 'Consumidor';           
            TCombo::reload('form_Cadpessoa', 'tipocliente', $options);            

            $options = array();
            $options['9'] = 'Não';           
            TCombo::reload('form_Cadpessoa', 'contribuinteicms', $options);

            $obj = new StdClass;
            $obj->contribuinteicms = '9';
            $obj->tipocliente = '1';   
  
            TForm::sendData('form_Cadpessoa', $obj);
            //TCombo::disableField('form_Cadpessoa','tipocliente');	        	        
            //TCombo::disableField('form_Cadpessoa','contribuinteicms');
	    }
	    else 
	    {
            $options = array();
            $options['1'] = 'Consumidor';
            $options['2'] = 'Revendedor';           
            TCombo::reload('form_Cadpessoa', 'tipocliente', $options);            

            $options = array();
            $options['1'] = 'Sim';
            $options['2'] = 'Isento';           
            TCombo::reload('form_Cadpessoa', 'contribuinteicms', $options);
            
            $obj = new StdClass;
            $obj->contribuinteicms = '1';   
            $obj->tipocliente = '1';       
            TForm::sendData('form_Cadpessoa', $obj);
            //TCombo::disableField('form_Cadpessoa','tipocliente');	        	        
            //TCombo::disableField('form_Cadpessoa','contribuinteicms');             	    
	    }	    	            	    
	}	 
    
}
