<?php
/*
ini_set('display_errors',1);
ini_set('display_startup_erros',1);
error_reporting(E_ALL);
/**
 * MovimentoitemList Listing
 * @author  <your name here>
 */
class MovimentoitemList extends TPage
{
    private $formitemitem; // formitem
    private $datagrid; // listing    
    /**
     * Class constructor
     * Creates the page, the formitem and the listing
     */
    public function __construct()
    {
        parent::__construct();        
        //parent::include_js('app/lib/include/application.js');
        //TPage::include_js('app/resources/eventosjs.js');
        //TScript::create('setTimeout(function() { $("input[name=\'produto\']").focus() }, 50);');         
        // creates the formitem
        echo 'Cadastro item' . '<br \>';
        $this->adianti_target_container = 'Movimentoitem_area';        
        $this->formitem = new BootstrapFormBuilder('form_MovimentoitemList');
        $this->formitem->setFieldSizes('100%');         
        $idmovimentotmp = $param['idmovimento']??'';
        $movimentoidtmp = $param['movimento_id']??'';
              
        $idmovimento = new THidden('idmovimento');
        $movimento_id = new THidden('movimento_id');
        $movimentoitem = new THidden('movimentoitem');
        $movimentoitem_loaded = new THidden('movimentoitem_loaded');
        $movimentoitem_count = new THidden('movimentoitem_count');
        $tipooperacao = new THidden('tipooperacao');
              
        
        $cadproduto_id = new TSeekButton('cadproduto_id');
        
        $obj = new PesquisaProdutosMovimentoitemList;
        $action = new TAction(array($obj, 'onReload'));
        $cadproduto_id->setAction($action);
          
        /*
        $btn = $buscaproduto = new TButton('buscaproduto');
        $btn->class = 'btn btn-sm btn-primary';
        $buscaproduto_action = new TAction(array('PesquisaProdutosMovimentoitemList', 'onReload'));
        $buscaproduto->setAction($buscaproduto_action, 'Buscar');
        //$buscaproduto->setImage('bs:plus-sign green');                 
        //$this->formitem->addFields([$buscaproduto_add]);        
        */
        $onExitcadproduto_id = new TAction(array($this, 'onExitCadproduto_id'));  
        $cadproduto_id->setExitAction($onExitcadproduto_id);               
        
        $produto = new TEntry('produto');
        $produtoservico = new THidden('produtoservico');
        $descontomaximo = new THidden('descontomaximo');        
        $unidade = new TEntry('unidade');
        $qtde = new TEntry('qtde');
        $unitario = new TEntry('unitario');
        $subtotal = new TEntry('subtotal');
        $desconto = new TEntry('desconto');
        $margem_desconto = new TEntry('margem_desconto');
        $total = new TEntry('total');
        
        //$totalgeral 

        $idmovimento->setValue($idmovimentotmp);
        $movimento_id->setValue($movimentoidtmp);
        
        $movimentoitem->setValue('movimentoitem'.'_'.$idmovimentotmp);
        $movimentoitem_loaded->setValue('movimentoitem_loaded'.'_'.$idmovimentotmp);
        $movimentoitem_count->setValue('movimentoitem_count'.'_'.$idmovimentotmp);
        $tipooperacao->setValue('tipooperacao'.'_'.$idmovimentotmp);         
        
        $onExitqtde = new TAction(array($this, 'onExitQtde'));  
        $qtde->setExitAction($onExitqtde);       
        
        $cadproduto_id->setSize('100%');
        $produto->setSize('100%');
        $produto->setEditable(False);
        $unidade->setSize('100%');

        $qtde->setNumericMask(2, ',', '.', true);
        $unitario->setNumericMask(2, ',', '.', true);
        $subtotal->setNumericMask(2, ',', '.', true);
        $total->setNumericMask(2, ',', '.', true);
        $desconto->setNumericMask(2, ',', '.', true);
        $margem_desconto->setNumericMask(2, ',', '.', true);
        
        $qtde->setSize('100%');
        $unitario->setSize('100%');
        $subtotal->setSize('100%');
        $margem_desconto->setSize('100%');
        $desconto->setSize('100%');
        $total->setSize('100%');
        
        $unidade->setEditable(False);
        $subtotal->setEditable(False);
        $total->setEditable(False);
        
        $subtotal->addValidation('SubTotal Inválido', new TMinValueValidator, array(0.1));
        $qtde->addValidation('Quantidade Inválida', new TMinValueValidator, array(0.1));
        $unitario->addValidation('Valor unitário Inválido', new TMinValueValidator, array(0.1));      
        /*
        $additem = TButton::create('additem', [ $this, 'onMovimentoitemListAdd'], 'Adcionar', 'fa:plus-circle green' );
        $additem->getAction()->setParameter('static','1'); 
        */
        
        $additem = new TButton('additem');
        $additem_action = new TAction(array($this, 'onMovimentoitemListAdd'));
        $additem->setAction($additem_action, 'Adcionar');
        $additem->setImage('bs:plus-sign green');                 
        //$additem->class = 'btn btn-sm btn-primary';
        
        //$additem->setImage('fa:chevron-down');
        $additem->style = 'font-size:16px;width:100%;height:30px;padding:0px;color:#FF4000;background-color: #F5F6CE;';               
                       
        //$this->formitem->addFields([$additem_add]);         
          
        //$btn = $this->formitem->addAction('Adcionar', new TAction([$this, 'onMovimentoitemListAdd']), 'fa:save');
        //$btn->class = 'btn btn-sm btn-primary';          
          
                     
        //$buscaproduto->setMask('{id} - {produto} - {precovenda}');
        //$buscaproduto->enableSearch();
        $this->formitem->addFields([$produtoservico],
                               [$descontomaximo]);
        $cadproduto_id->setSize('100%');
        $this->formitem->addFields([$idmovimento],[$movimento_id],[$movimentoitem],[$movimentoitem_count],[$movimentoitem_loaded],[$tipooperacao]);
        $row = $this->formitem->addFields([new TLabel('Produto'),$cadproduto_id], //[new TLabel(''), $buscaproduto], 
                                      [new TLabel('Descrição'), $produto],
                                      [new TLabel('Unidade'),$unidade]);
        $row->layout = ['col-sm-2','col-sm-9','col-sm-1'];                                      
                                        
        $row = $this->formitem->addFields([new TLabel('Qtde.') , $qtde],
                                      [new TLabel('Unitário') , $unitario],
                                      [new TLabel('Subtotal'), $subtotal],
                                      [new TLabel('Desc. %'), $margem_desconto],
                                      [new TLabel('Desconto R$'), $desconto],
                                      [new TLabel('Total'), $total],
                                      [new TLabel('<br>','#21610B'),$additem]); 
        $row->layout = ['col-sm-1','col-sm-2','col-sm-2','col-sm-1','col-sm-2','col-sm-2','col-sm-2'];
        //$this->formitem->addFields([$additem]);                                
        // creates a Datagrid
        $this->datagrid = new TDataGrid;
        $this->datagrid = new BootstrapDatagridWrapper($this->datagrid);
        $this->datagrid->style = 'width: 100%';
        $this->datagrid->datatable = 'true';
        // $this->datagrid->enablePopover('Popover', 'Hi <b> {name} </b>');
        // make scrollable and define height
        $this->datagrid->setHeight(200);
        $this->datagrid->makeScrollable();        

        // creates the datagrid columns
        $column_item          = new TDataGridColumn('item',          'Item',     'center', '5%');        
        $column_cadproduto_id = new TDataGridColumn('cadproduto_id', 'Código',   'center', '5%');
        $column_produto       = new TDataGridColumn('produto',       'Produto',  'left',  '30%');
        $column_unidade       = new TDataGridColumn('unidade',       'Und.',     'center','5%');
        $column_qtde          = new TDataGridColumn('qtde',          'Qtde.',    'right','15%');
        $column_unitario      = new TDataGridColumn('unitario',      'Unitário', 'right','10%');
        $column_subtotal      = new TDataGridColumn('subtotal',      'Subtotal', 'right', '10%');        
        $column_desconto      = new TDataGridColumn('desconto',      'Desconto', 'right', '10%');
        $column_total         = new TDataGridColumn('total',         'Total',    'right', '10%');
                        
        
        
        //movimentoitem
        // add the columns to the DataGrid
        $this->datagrid->addColumn($column_item);
        $this->datagrid->addColumn($column_cadproduto_id);
        $this->datagrid->addColumn($column_produto);
        $this->datagrid->addColumn($column_unidade);
        $this->datagrid->addColumn($column_qtde);
        $this->datagrid->addColumn($column_unitario);
        $this->datagrid->addColumn($column_subtotal);
        $this->datagrid->addColumn($column_desconto);
        $this->datagrid->addColumn($column_total);               
        /*
        // create EDIT action
        $action_edit = new TDataGridAction(array('MovimentoitemList', 'onMovimentoitemListEdi'));
        //$action_edit->setUseButton(TRUE);
        //$action_edit->setButtonClass('btn btn-default');
        $action_edit->setLabel(_t('Edit'));
        $action_edit->setImage('far:edit blue fa-lg');
        $action_edit->setField('idmovimento');
        $this->datagrid->addAction($action_edit);
        */
        // create DELETE action
        $action_del = new TDataGridAction(array($this, 'onMovimentoitemListDel'));
        //$action_del->setUseButton(TRUE);
        //$action_del->setButtonClass('btn btn-default');
        $action_del->setLabel(_t('Delete'));
        $action_del->setImage('far:trash-alt red fa-lg');
        $action_del->setField('idmovimento');
        $this->datagrid->addAction($action_del);

        /*
        $action_group = new TDataGridActionGroup('Ações', 'bs:th');        
        $action_group->addHeader('Cadastro');
        $action_group->addAction($action_edit);
        $action_group->addAction($action_del);*/       
        // add the actions to the datagrid
        //$this->datagrid->addActionGroup($action_group);        
        
        
       
        
        // create the datagrid model
        $this->datagrid->createModel();
        //$this->formitem->addContent([$this->datagrid]);    
        // vertical box container
        $container = new TVBox;
        $container->style = 'width: 100%';
        // $container->add(new TXMLBreadCrumb('menu.xml', __CLASS__));
        $container->add($this->formitem);
        $container->add(TPanelGroup::pack('', $this->datagrid));
        //$container->add(TPanelGroup::pack('', $this->datagrid, $this->pageNavigation));        
        parent::add($container);        
    }

    public function onEdit( $param )
    {
        try
        {
            /*
            TSession::delValue($param['movimentoitem']);
            TSession::delValue($param['movimentoitem_loaded']);            
            TSession::delValue($param['movimentoitem_count']);
            TSession::delValue($param['tipooperacao']);
            */ 
            echo var_dump($param) . ' onEdit MovimentoitemList ' . '<br \>';          
            $data = $this->formitem->getData();
            $data->idmovimento = $param['idmovimento'];
            
            $idmovimento = $param['idmovimento'];
                    
            $data->movimentoitem = 'movimentoitem'.'_'.$idmovimento;
            $data->movimentoitem_loaded = 'movimentoitem_loaded'.'_'.$idmovimento;
            $data->movimentoitem_count = 'movimentoitem_count'.'_'.$idmovimento;
            $data->tipooperacao = 'tipooperacao'.'_'.$idmovimento;             
            //echo print_r($data);
            $this->formitem->setData($data);
            $key = '';               
            if (isset($param['key']))
            {                
                //echo var_dump($param);
                $key = $param;
                $this->loadMovimentoitem($key);                 
                $this->onReload();                                                                              
            }
            elseif (!empty($idmovimento))
            {
                echo 'idmovimento onedit' . '<br \>';
                $key = $param['idmovimento'];  
                $this->onReload();              
            }
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }
    
    public function onClear( $param )
    {
        $this->formitem->clear(TRUE);                        
    }   
    
    public function onMostraTelaItem($param)
    {
        //echo var_dump($param) . 'Id Sessao' . '<br \>';
        $tipooperacao = TSession::getValue($param['tipooperacao']);
        //echo var_dump($tipooperacao) . '<br \>';
        
        if ($tipooperacao)
        {
            
            //foreach ($tipooperacao as $tipooperacao_id => $tipooperacaoitem)
                        
                if ($tipooperacao['itemusadesconto'] == 'S'){
                    TEntry::enableField('form_MovimentoitemList','desconto');
                    TEntry::enableField('form_MovimentoitemList','margem_desconto');                                                
                } else {
                    TEntry::disableField('form_MovimentoitemList','desconto');
                    TEntry::disableField('form_MovimentoitemList','margem_desconto');                       
                }            
                if ($tipooperacao['itemeditavalor'] == 'S') {
                    TEntry::enableField('form_MovimentoitemList','unitario');
                    TEntry::enableField('form_MovimentoitemList','unitario');                                                     
                } else {
                    TEntry::disableField('form_MovimentoitemList','unitario');
                    TEntry::disableField('form_MovimentoitemList','unitario');                       
                } 
             
            TDBCombo::disableField('form_Movimento','cadtipooperacao_id');          
            /*
            $tipooperacaotmp['itemprodutoduplicado'] = $cadtipooperacao->itemprodutoduplicado;
            $tipooperacaotmp['itemservicoduplicado'] = $cadtipooperacao->itemservicoduplicado;
            $tipooperacaotmp['itemservicoduplicado'] = $cadtipooperacao->itemvendedor;
            $tipooperacaotmp['itemservicoduplicado'] = $cadtipooperacao->itemvendedorautomatico;
            $tipooperacaotmp['itemservicoduplicado'] = $cadtipooperacao->itemvendedorobrigatorio;
            */          
        }
                
       
    } 
    
    /**
     * Load the datagrid with data
     */
    public function onReload( $param = null)
    {
        try
        {               
            $data = $this->formitem->getData();            
            $data->cadproduto_id = '';
            $data->produto = '';
            $data->qtde = '';
            $data->unitario = 0;
            $data->subtotal = 0;
            $data->desconto = 0;
            $data->margem_desconto = 0;
            $data->total = 0;
            $data->unidade = '';            
            if (isset($param))
            {
                $data->movimentoitem_loaded = $param['movimentoitem_loaded'];
                $data->movimentoitem_count = $param['movimentoitem_count'];
                $data->movimentoitem = $param['movimentoitem'];
                $data->tipooperacao = $param['tipooperacao'];
                $loadparam = True;
            }
            else
            {
                $param['movimentoitem_loaded'] = $data->movimentoitem_loaded;
                $param['movimentoitem_count'] = $data->movimentoitem_count;
                $param['movimentoitem'] = $data->movimentoitem;
                $param['tipooperacao'] = $data->tipooperacao;                
            }     
            //echo var_dump($data);
            $itens = 0 ;
            $totalprodutos = 0;
            $totalservicos = 0;
            $totaldesconto = 0;
            $totalliquido = 0;
            //echo var_dump($data) . '<br \>';
            //HDebug::debug(TSession::getValue($param['movimentoitem_loaded']),'Reload Movimento Item');
            if (!empty(TSession::getValue($param['movimentoitem_loaded'])))            
            {    
                //$data = $this->formitem->getData(); // get formitem data as array                                   
                $movimentoitemlist = TSession::getValue($param['movimentoitem']);                         
                $this->datagrid->clear();                            
                if ($movimentoitemlist)
                {                                                                 
                    //var_dump($movimentoitemlist);                 
                    TTransaction::open('goldnotas'); // open a transaction                
                    foreach ($movimentoitemlist as $movimentoitem_id => $movimentoitem)
                    {   // add the object inside the datagrid
                        if ($movimentoitem['del'] == 'N')
                        {
                            $item = new StdClass;                   
                            $item->key = $movimentoitem['key'];                                   
                            $item->item  = $movimentoitem['item'];
                            $item->cadproduto_id = $movimentoitem['cadproduto_id'];
                            $item->produto = $movimentoitem['produto'];            
                            $item->qtde = $movimentoitem['qtde'];
                            $item->unidade = $movimentoitem['unidade'];
                            $item->unitario = $movimentoitem['unitario'];
                            $item->subtotal = $movimentoitem['subtotal'];
                            $item->desconto = $movimentoitem['desconto'];
                            $item->margem_desconto = $movimentoitem['margem_desconto'];
                            $item->total = $movimentoitem['total'];
                            $item->idmovimento = $movimentoitem['idmovimento'];                                           
                            $this->datagrid->addItem($item);
                            $itens++;
                            if ($movimentoitem['produtoservico'] == 'P')
                            {
                                $totalprodutos = $totalprodutos + $movimentoitem['subtotal']; 
                            }
                            else
                            {
                                $totalservicos = $totalservicos + $movimentoitem['subtotal'];    
                            }
                            $totaldesconto = $totaldesconto + $movimentoitem['desconto'];
                            $totalliquido = $totalliquido + $movimentoitem['total'];  
                        }                        
                    }
                    TTransaction::close();                    
                }   
                $this->formitem->setData($data);                
                $obj = new StdClass;
                if (isset($loadparam))
                {
                    $obj->movimentoitem_loaded = $param['movimentoitem_loaded'];
                    $obj->movimentoitem_count = $param['movimentoitem_count'];
                    $obj->movimentoitem = $param['movimentoitem'];
                    $obj->tipooperacao = $param['tipooperacao'];                        
                }                
                $obj->itens = $itens;
                $obj->total_produtos =  number_format($totalprodutos, 2, ',', '.');
                $obj->total_servicos = number_format($totalservicos, 2, ',', '.');
                $obj->subtotalgeral = number_format($totalprodutos + $totalservicos, 2, ',', '.');
                $obj->descontogeral = number_format($totaldesconto, 2, ',', '.');
                $obj->totalgeral = number_format($totalliquido, 2, ',', '.');
                TForm::sendData('form_Movimento', $obj, False, False);	 
                $this->onMostraTelaItem(['tipooperacao' => $param['tipooperacao']]);               
                TScript::create('setTimeout(function() { $("input[name=\'cadproduto_id\']").focus() }, 500);');              
            }          
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->formitem->setData( $this->formitem->getData() ); // keep formitem data
        }
    }

    public function onMovimentoitemListAdd($param)
    {               
        try
        {
            //echo var_dump($param) . '<br \>';
            $tipooperacao = TSession::getValue($param['tipooperacao']);                                                               
            if (!$tipooperacao)
            {
                throw new Exception('Tipo de Operação não informitemado!');     
            }             
            //echo var_dump($tipooperacao) . '<br \>';   
            //$this->formitem->validate();         
            $data = $this->formitem->getData();
            if ($data->qtde <= 0)
            {             
                $this->formitem->setData( $data);
                $this->onReload();               
                throw new Exception('Quantidade não informitemada!!');
            }
            
            
            //$this->formitem->validate();
            $idmovimento = $param['idmovimento'];
            $movimentoitem = TSession::getValue($param['movimentoitem']);  
            $idmovimento = $param['idmovimento'];
                              
            $movimentoitem_count = TSession::getValue($param['movimentoitem_count']);
            $movimentoitem_count++;            
            TSession::setValue($param['movimentoitem_count'], $movimentoitem_count);                                                      
            $movimentoitem[$movimentoitem_count] = array(
                                                        'key' => $movimentoitem_count,
                                                        'item' => $movimentoitem_count,
                                                        'cadproduto_id' => $param['cadproduto_id'],                                                                                                       
                                                        'produto' => $param['produto'],
                                                        'unidade' => $param['unidade'],
                                                        'qtde' => $param['qtde'],
                                                        'unitario' => $param['unitario'],
                                                        'subtotal' => $param['subtotal'],
                                                        'desconto' => $param['desconto'],
                                                        'margem_desconto' => $param['margem_desconto'],
                                                        'total' => $param['total'],  
                                                        'idmovimento' => $movimentoitem_count . '_' . $idmovimento, 
                                                        'produtoservico' => $param['produtoservico'],
                                                        'descontomaximo' => $param['descontomaximo'],                                                                                                              
                                                        'del' => 'N');
            //HDebug::debug($movimentoitem,'Salvar Movimento Item');     
            
            TSession::setValue($param['movimentoitem_count'], $movimentoitem_count);                    
            TSession::setValue($param['movimentoitem_loaded'], true);
            TSession::setValue($param['movimentoitem'], $movimentoitem);            
            $this->onReload();                       
        }
        catch (Exception $e)
        {
            $this->formitem->setData( $this->formitem->getData());
            $this->onReload();
            new TMessage('error', $e->getMessage());
        }                          
    }
    
    public function onMovimentoitemListEdi($param)
    {               
        try 
        {                           
            $data = $this->formitem->getData();
            $key=$param['key'];                    
        }
        catch (Exception $e)
        {
            new TMessage('error', $e->getMessage());
        }                          
    }

    public function onMovimentoitemListDel($param)
    {
        try
        {

            $key=$param['idmovimento']; // get the parameter $key           
            $pos = strpos($key,'_');
            $tam = strlen($key);
            $id = substr($key, 0, $pos);
            $idmovimento = substr($key, $pos + 1, $tam - $pos);
            /*
            echo 'key = ' . $key . '<br \>';
            echo 'id = ' . $id . '<br \>';
            echo 'idmovimento = ' . $movimentoid . '<br \>';
            */
            $param['movimentoitem']        = 'movimentoitem_'.$idmovimento;
            $param['movimentoitem_loaded'] = 'movimentoitem_loaded'.'_'.$idmovimento;
            $param['movimentoitem_count']  = 'movimentoitem_count'.'_'.$idmovimento;
            $param['tipooperacao']  = 'tipooperacao'.'_'.$idmovimento;            
            //echo var_dump($param);
            echo 'Del = ' . $param['movimentoitem'] . '<br \>';
            $movimentoitem = TSession::getValue($param['movimentoitem']);
            $movimentoitem[$id]['del'] = 'S';   
            //var_dump($movimentoitem);
            TSession::setValue($param['movimentoitem'], $movimentoitem);         
            $this->onReload($param);
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            TTransaction::rollback(); // undo all pending operations
        }
    }

    function loadMovimentoitem($idmovimento)
    {
        if(is_numeric($idmovimento))
        {
            try
            {           
                if(!TSession::getValue($param['movimentoitem_loaded'])) 
                {
                    $movimentoitem = TSession::delValue($param['movimentoitem']); 
                    TTransaction::open('goldnotas');                    
                    $movimentoitem_criteria = new TCriteria;                     
                    $movimentoitem_criteria->add(new TFilter('movimento_id', '=', $idmovimento));
                     
                    $repository = new TRepository('Movimentoitem'); 
                    $movimentoitem_repo = $repository->load($movimentoitem_criteria);
                    $movimentoitem_max_ordem = 0;
                    $movimentoitem_count = 0 ;                    
                    foreach ($movimentoitem_repo as $movimentoitem_obj) 
                    {                                             
                        $movimentoitem_count++;                                                                       
                        $movimentoitem[$movimentoitem_count] = array(
                                                  'key' => $movimentoitem_count,
                                                  'item' => $movimentoitem_count,
                                                  'cadproduto_id' => $movimentoitem_obj->cadproduto_id,                                                  
                                                  'produto' => $movimentoitem_obj->produto,
                                                  'unidade' => $movimentoitem_obj->unidade,
                                                  'qtde' => $movimentoitem_obj->qtde,
                                                  'unitario' => $movimentoitem_obj->unitario,
                                                  'subtotal' => $movimentoitem_obj->subtotal,
                                                  'desconto' => $movimentoitem_obj->desconto,
                                                  'margem_desconto' => $movimentoitem_obj->margem_desconto,
                                                  'total' => $movimentoitem_obj->total,  
                                                  'idmovimento' => $movimentoitem_count . '_' . $idmovimento,                                                
                                                  'del' => 'N');  
                                                                        
                    }
 
                    TSession::setValue($param['movimentoitem_count'], $movimentoitem_count);                    
                    TSession::setValue($param['movimentoitem_loaded'], true);
                    TSession::setValue($param['movimentoitem'], $movimentoitem);                     
                    TTransaction::close(); 
                    
                }
            }
            catch (Exception $e)
            {
                TTransaction::rollback(); 
                new TMessage('error', $e->getMessage());
            }
        }
        return true;  
    }
    
    public static function onExitCadproduto_id($param)
    {
        if (!empty($param['cadproduto_id']))
        {            
            try   
            {          
                //echo $param['idmovimento'] . '<br \>';
                TTransaction::open('goldnotas'); 
                $criteria = new TCriteria;
                $criteria->add(new TFilter('id', '=', "{$param['cadproduto_id']}"), TExpression::OR_OPERATOR); 
                $criteria->add(new TFilter('codbarras','=', "%{$param['cadproduto_id']}%"), TExpression::OR_OPERATOR);
                $criteria->add(new TFilter('referencia','=', "%{$param['cadproduto_id']}%"), TExpression::OR_OPERATOR);
                $criteria->add(new TFilter('reffabricante','=', "%{$param['cadproduto_id']}%"), TExpression::OR_OPERATOR);             
                //echo $criteria->dump(); // (nome like 'pedro%' OR nome like 'maria%')
                
                // load using repository
                $repository = new TRepository('Cadproduto'); 
                $cadprodutos = $repository->load($criteria); 
                 
                foreach ($cadprodutos as $cadproduto) 
                {                     
                    $object = new StdClass;
                    $object->cadproduto_id = $cadproduto->id;
                    $object->produto = $cadproduto->produto;
                    $object->unidade = $cadproduto->unidade;           
                    $object->unitario =  number_format($cadproduto->precovenda, 2, ',', '.');
                    $object->produtoservico = $cadproduto->produtoservico;
                    $object->descontomaximo = $cadproduto->descontomaximo;                    
                    TForm::sendData('form_MovimentoitemList', $object,False,False);
                    TScript::create('setTimeout(function() { $("input[name=\'qtde\']").focus() }, 500);');
                    break;                     
                }                
                TTransaction::close();
            }
            catch (Exception $e) // in case of exception
            {
                new TMessage('error', $e->getMessage()); // shows the exception error message
                $this->formitem->setData( $this->formitem->getData() ); // keep formitem data
                TTransaction::rollback(); // undo all pending operations
            }                                         
        }
    }
    
    public static function onExitQtde($param)
    {                        
        $qtde   = $param['qtde'];//(double) PMaskFormate::formata_valor($param['qtde']);
        $unitario   = $param['unitario'];//(double) PMaskFormate::formata_valor($param['unitario']);
        $subtotal  = 0;
        $desconto = 0;
        $margemdesconto = 0;                
        $total  = 0;
	    if (($qtde > 0) and ($unitario > 0))
	    {
            $subtotal  = ($qtde * $unitario);          
            $subtotal  = PMaskFormate::formata_valor($subtotal);
            $total  = $subtotal;                                    	        
	    }            
        $obj = new StdClass;
        $obj->subtotal = $subtotal;
        $obj->total = $total;
        $obj->desconto = $desconto;
        $obj->margemdesconto = $margemdesconto;
        TForm::sendData('form_MovimentoitemList', $obj, False, False);	    
    }   
    
    public static function onChangecampopesquisa($param)
    {
        try   
        {         
            switch($param['campopesquisa'])
            {
                case "0":
                    $campopesquisa = 'id';
                    break;
                case "1":
                    $campopesquisa = 'produto';
                    break;
                case "2":
                    $campopesquisa = 'codbarras';
                    break;
                case "3":
                    $campopesquisa = 'referencia';
                    break;
                case "4":
                    $campopesquisa = 'reffabricante';
                    break;                                                
            }            
            $filtro = new TCriteria;                     
            $filtro->add(new TFilter('ativo', '=', 'S'));
            TTransaction::open('goldnotas');                                   
            TTransaction::dump();
            TDBCombo::reloadFromModel('formitem_MovimentoitemList','buscaproduto','goldnotas','Cadproduto','id',"{$campopesquisa}",'produto', null, $filtro, false, false);
            TTransaction::close();                                   
 
        }
        catch (Exception $e) // in case of exception
        {
            new TMessage('error', $e->getMessage()); // shows the exception error message
            $this->formitem->setData( $this->formitem->getData() ); // keep formitem data
            TTransaction::rollback(); // undo all pending operations
        }                
        
    }     

}
