<?php
/**
 * Cadcondpgto Active Record
 * @author  <your-name-here>
 */
class Cadcondpgto extends TRecord
{
    const TABLENAME = 'cadcondpgto';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $avistacadformapgto;
    private $aprazocadformapgto;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('descricao');
        parent::addAttribute('avista');
        parent::addAttribute('qtd_parcs');
        parent::addAttribute('dias_primparc');
        parent::addAttribute('dias_entreparc');
        parent::addAttribute('dias_alterapac');
        parent::addAttribute('perc_entrada');
        parent::addAttribute('percentual');
        parent::addAttribute('desconto_maximo');
        parent::addAttribute('liberada_consumidor');
        parent::addAttribute('ativo');
        parent::addAttribute('disp_compras');
        parent::addAttribute('disp_vendas');
        parent::addAttribute('avista_cadformapgto_id');
        parent::addAttribute('aprazo_cadformapgto_id');
    }

    
    /**
     * Method set_cadformapgto
     * Sample of usage: $cadcondpgto->cadformapgto = $object;
     * @param $object Instance of Cadformapgto
     */
    public function set_avistacadformapgto(Cadformapgto $object)
    {
        $this->avistacadformapgto = $object;
        $this->avistacadformapgto_id = $object->id;
    }
    
    /**
     * Method get_cadformapgto
     * Sample of usage: $cadcondpgto->cadformapgto->attribute;
     * @returns Cadformapgto instance
     */
    public function get_avistacadformapgto()
    {
        // loads the associated object
        if (empty($this->avistacadformapgto))
            $this->avistacadformapgto = new Cadformapgto($this->avistacadformapgto_id);
    
        // returns the associated object
        return $this->avistacadformapgto;
    }
    
    
    /**
     * Method set_cadformapgto
     * Sample of usage: $cadcondpgto->cadformapgto = $object;
     * @param $object Instance of Cadformapgto
     */
    public function set_aprazocadformapgto(Cadformapgto $object)
    {
        $this->aprazocadformapgto = $object;
        $this->aprazocadformapgto_id = $object->id;
    }
    
    /**
     * Method get_cadformapgto
     * Sample of usage: $cadcondpgto->cadformapgto->attribute;
     * @returns Cadformapgto instance
     */
    public function get_aprazocadformapgto()
    {
        // loads the associated object
        if (empty($this->aprazocadformapgto))
            $this->aprazocadformapgto = new Cadformapgto($this->aprazocadformapgto_id);
    
        // returns the associated object
        return $this->aprazocadformapgto;
    }
    


}
