<?php
/**
 * Cadcontacorrente Active Record
 * @author  <your-name-here>
 */
class Cadcontacorrente extends TRecord
{
    const TABLENAME = 'cadcontacorrente';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcontacorrenteorigem;
    private $cadplanoconta;
    private $cadcentrocusto;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('contacorrente');
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('tipo');
        parent::addAttribute('nrcontacorrente');
        parent::addAttribute('nragencia');        
        parent::addAttribute('nomeagencia');
        parent::addAttribute('ativo');
        parent::addAttribute('cadbanco_id');
        parent::addAttribute('cadcentrocusto_id');
        parent::addAttribute('cadplanoconta_id');
    }

    
    /**
     * Method set_cadcontacorrenteorigem
     * Sample of usage: $cadcontacorrente->cadcontacorrenteorigem = $object;
     * @param $object Instance of Cadcontacorrenteorigem
     */
    public function set_cadcontacorrenteorigem(Cadcontacorrenteorigem $object)
    {
        $this->cadcontacorrenteorigem = $object;
        $this->cadcontacorrenteorigem_id = $object->id;
    }
    
    /**
     * Method get_cadcontacorrenteorigem
     * Sample of usage: $cadcontacorrente->cadcontacorrenteorigem->attribute;
     * @returns Cadcontacorrenteorigem instance
     */
    public function get_cadcontacorrenteorigem()
    {
        // loads the associated object
        if (empty($this->cadcontacorrenteorigem))
            $this->cadcontacorrenteorigem = new Cadcontacorrenteorigem($this->cadcontacorrenteorigem_id);
    
        // returns the associated object
        return $this->cadcontacorrenteorigem;
    }
    
    
    /**
     * Method set_cadplanoconta
     * Sample of usage: $cadcontacorrente->cadplanoconta = $object;
     * @param $object Instance of Cadplanoconta
     */
    public function set_cadplanoconta(Cadplanoconta $object)
    {
        $this->cadplanoconta = $object;
        $this->cadplanoconta_id = $object->id;
    }
    
    /**
     * Method get_cadplanoconta
     * Sample of usage: $cadcontacorrente->cadplanoconta->attribute;
     * @returns Cadplanoconta instance
     */
    public function get_cadplanoconta()
    {
        // loads the associated object
        if (empty($this->cadplanoconta))
            $this->cadplanoconta = new Cadplanoconta($this->cadplanoconta_id);
    
        // returns the associated object
        return $this->cadplanoconta;
    }
    
    
    /**
     * Method set_cadcentrocusto
     * Sample of usage: $cadcontacorrente->cadcentrocusto = $object;
     * @param $object Instance of Cadcentrocusto
     */
    public function set_cadcentrocusto(Cadcentrocusto $object)
    {
        $this->cadcentrocusto = $object;
        $this->cadcentrocusto_id = $object->id;
    }
    
    /**
     * Method get_cadcentrocusto
     * Sample of usage: $cadcontacorrente->cadcentrocusto->attribute;
     * @returns Cadcentrocusto instance
     */
    public function get_cadcentrocusto()
    {
        // loads the associated object
        if (empty($this->cadcentrocusto))
            $this->cadcentrocusto = new Cadcentrocusto($this->cadcentrocusto_id);
    
        // returns the associated object
        return $this->cadcentrocusto;
    }

    
    /**
     * Method set_cadbanco
     * Sample of usage: $cadcaixacontacorrente->cadbanco = $object;
     * @param $object Instance of Cadbanco
     */
    public function set_cadbanco(Cadbanco $object)
    {
        $this->cadbanco = $object;
        $this->cadbanco_id = $object->id;
    }
    
    /**
     * Method get_cadbanco
     * Sample of usage: $cadcaixacontacorrente->cadbanco->attribute;
     * @returns Cadbanco instance
     */
    public function get_cadbanco()
    {
        // loads the associated object
        if (empty($this->cadbanco))
            $this->cadbanco = new Cadbanco($this->cadbanco_id);
    
        // returns the associated object
        return $this->cadbanco;
    }

    public function get_banco()
    {
        // loads the associated object
        if (empty($this->cadbanco))
            $this->cadbanco = new Cadbanco($this->cadbanco_id);
    
        // returns the associated object
        return $this->cadbanco->nrbanco. ' - '. $this->cadbanco->banco;
    }    
}
