<?php
/**
 * Cadempresa Active Record
 * @author  <your-name-here>
 */
class Cadempresa extends TRecord
{
    const TABLENAME = 'cadempresa';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcidade;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('empresa');
        parent::addAttribute('fantasia');
        parent::addAttribute('endereco');
        parent::addAttribute('numero');
        parent::addAttribute('cep');
        parent::addAttribute('bairro');
        parent::addAttribute('complemento');
        parent::addAttribute('cadcidade_id');
        parent::addAttribute('telefone1');
        parent::addAttribute('telefone2');
        parent::addAttribute('cnae');
        parent::addAttribute('dtabertura');
        parent::addAttribute('cnpj');
        parent::addAttribute('inscricaoestadual');
        parent::addAttribute('inscricaomunicipal');
        parent::addAttribute('atividademunicipal');
        parent::addAttribute('email');
        parent::addAttribute('website');
        parent::addAttribute('responsavel');
        parent::addAttribute('eslogan');
        parent::addAttribute('crt');
        parent::addAttribute('aliquota_ipi');
        parent::addAttribute('aliquota_iss');
        parent::addAttribute('aliquota_pis');
        parent::addAttribute('aliquota_cofins');
        parent::addAttribute('ativo');
        parent::addAttribute('logo');
        parent::addAttribute('contador_cadpessoa_id');
    }

    
    /**
     * Method set_cadcidade
     * Sample of usage: $cadempresa->cadcidade = $object;
     * @param $object Instance of Cadcidade
     */
    /*
    public function set_cadcidade(Cadcidade $object)
    {
        $this->cadcidade = $object;
        $this->cadcidade_id = $object->id;
    }
    */
    /**
     * Method get_cadcidade
     * Sample of usage: $cadempresa->cadcidade->attribute;
     * @returns Cadcidade instance
     */
    public function get_cadcidade()
    {
        // loads the associated object
        if (empty($this->cadcidade))
            $this->cadcidade = new Cadcidade($this->cadcidade_id);
    
        // returns the associated object
        return $this->cadcidade;
    }
                            
    public function get_cidade_uf_cadcidade()
    {
        // loads the associated object
        if (empty($this->cadcidade))
            $this->cadcidade = new Cadcidade($this->cadcidade_id);
    
        // returns the associated object
        return $this->cadcidade->cidade . ' - ' . $this->cadcidade->nomeuf;      
    }
    
    public function get_cidade_uf()
    {
        // loads the associated object
        if (empty($this->cadcidade))
            $this->cadcidade = new Cadcidade($this->cadcidade_id);
    
        // returns the associated object
        return $this->cadcidade->uf;      
    }    
    
    public function onAfterStore($object)
    {
        $unidade = SystemUnit::find($object->id);                                             
        $unidade->id = $object->id;
        $unidade->name = $object->empresa;
        $unidade->store();        
    }    

}
