<?php
/**
 * CadpessoaCadplg Active Record
 * @author  <your-name-here>
 */
class CadpessoaCadplg extends TRecord
{
    const TABLENAME = 'cadpessoa_cadplg';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}       
    private $cadpessoa;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('numeroplg');
        parent::addAttribute('vencimentoplg');
        parent::addAttribute('processodnpm');
        parent::addAttribute('localidadeaurifera');
        parent::addAttribute('regiaoaurifera');
        parent::addAttribute('cadpessoa_id');
    }    
    /**
     * Method set_cadpessoa
     * Sample of usage: $cadpessoa_cadplg->cadpessoa = $object;
     * @param $object Instance of Cadpessoa
     */
    public function set_cadpessoa(Cadpessoa $object)
    {
        $this->cadpessoa = $object;
        $this->cadpessoa_id = $object->id;
    }    
    /**
     * Method get_cadpessoa
     * Sample of usage: $cadpessoa_cadplg->cadpessoa->attribute;
     * @returns Cadpessoa instance
     */
    public function get_cadpessoa()
    {
        // loads the associated object
        if (empty($this->cadpessoa))
            $this->cadpessoa = new Cadpessoa($this->cadpessoa_id);    
        // returns the associated object
        return $this->cadpessoa;
    }    
}
