<?php
/**
 * Cfgempresa Active Record
 * @author  <your-name-here>
 */
class Cfgempresa extends TRecord
{
    const TABLENAME = 'cfgempresa';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadempresa;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('ramoatividade');
        parent::addAttribute('fin_mascaraplanocontas');
        parent::addAttribute('cadalmoxarifado_id');
        parent::addAttribute('cadcaixacontacorrente_id');
    }

    
    /**
     * Method set_cadempresa
     * Sample of usage: $cfgempresa->cadempresa = $object;
     * @param $object Instance of Cadempresa
     */
    public function set_cadempresa(Cadempresa $object)
    {
        $this->cadempresa = $object;
        $this->cadempresa_id = $object->id;
    }
    
    /**
     * Method get_cadempresa
     * Sample of usage: $cfgempresa->cadempresa->attribute;
     * @returns Cadempresa instance
     */
    public function get_cadempresa()
    {
        // loads the associated object
        if (empty($this->cadempresa))
            $this->cadempresa = new Cadempresa($this->cadempresa_id);
    
        // returns the associated object
        return $this->cadempresa;
    }
    
    public function get_empresa()
    {
        // loads the associated object
        if (empty($this->cadempresa))
            $this->cadempresa = new cadempresa($this->cadempresa_id);
    
        // returns the associated object
        return $this->cadempresa->empresa;
    } 

}
