<?php
/**
 * Movcaixacontacorrente Active Record
 * @author  <your-name-here>
 */
class Movcaixacontacorrente extends TRecord
{
    const TABLENAME = 'movcaixacontacorrente';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcaixacontacorrente;
    private $cadcaixacontacorrenteorigem;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('cadcaixacontacorrente_id');
        parent::addAttribute('tipo');
        parent::addAttribute('historico');
        parent::addAttribute('valor');
        parent::addAttribute('compensado');
        parent::addAttribute('datalancamento');
        parent::addAttribute('datacompensado');
        parent::addAttribute('cadcaixacontacorrenteorigem_id');
        parent::addAttribute('system_user_id');
        parent::addAttribute('movcaixacontacorrente_transf_id');
        parent::addAttribute('cadcaixacontacorrentetipopagamento_id');
    }

    
    /**
     * Method set_cadcaixacontacorrente
     * Sample of usage: $movcaixacontacorrente->cadcaixacontacorrente = $object;
     * @param $object Instance of Cadcaixacontacorrente
     */
    public function set_cadcaixacontacorrente(Cadcaixacontacorrente $object)
    {
        $this->cadcaixacontacorrente = $object;
        $this->cadcaixacontacorrente_id = $object->id;
    }
    
    /**
     * Method get_cadcaixacontacorrente
     * Sample of usage: $movcaixacontacorrente->cadcaixacontacorrente->attribute;
     * @returns Cadcaixacontacorrente instance
     */
    public function get_cadcaixacontacorrente()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrente))
            $this->cadcaixacontacorrente = new Cadcaixacontacorrente($this->cadcaixacontacorrente_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrente;
    }
    
    public function get_nome_caixacontacorrente()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrente))
            $this->cadcaixacontacorrente = new Cadcaixacontacorrente($this->cadcaixacontacorrente_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrente->caixacontacorrente;
    }   
    
    /**
     * Method set_cadcaixacontacorrenteorigem
     * Sample of usage: $movcaixacontacorrente->cadcaixacontacorrenteorigem = $object;
     * @param $object Instance of Cadcaixacontacorrenteorigem
     */
    public function set_cadcaixacontacorrenteorigem(Cadcaixacontacorrenteorigem $object)
    {
        $this->cadcaixacontacorrenteorigem = $object;
        $this->cadcaixacontacorrenteorigem_id = $object->id;
    }
    
    /**
     * Method get_cadcaixacontacorrenteorigem
     * Sample of usage: $movcaixacontacorrente->cadcaixacontacorrenteorigem->attribute;
     * @returns Cadcaixacontacorrenteorigem instance
     */
    public function get_cadcaixacontacorrenteorigem()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrenteorigem))
            $this->cadcaixacontacorrenteorigem = new Cadcaixacontacorrenteorigem($this->cadcaixacontacorrenteorigem_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrenteorigem;
    }                        
    public function get_nome_caixacontacorrenteorigem()
    {
        // loads the associated object
        $cadcaixacontacorrenteorigem = new Cadcaixacontacorrenteorigem($this->cadcaixacontacorrenteorigem_id);    
        // returns the associated object
        return $cadcaixacontacorrenteorigem->caixacontacorrenteorigem;            
    }     

    public function get_login_systemuser()
    {
        // loads the associated object
        if (empty($this->systemuser))
            $this->systemuser = new SystemUser($this->system_user_id);
    
        // returns the associated object
        return $this->systemuser->login;            
    }
    
    /**
     * Method set_cadcaixacontacorrentetipopagamento
     * Sample of usage: $movcaixacontacorrente->cadcaixacontacorrentetipopagamento = $object;
     * @param $object Instance of Cadcaixacontacorrentetipopagamento
     */
    public function set_cadcaixacontacorrentetipopagamento(Cadcaixacontacorrentetipopagamento $object)
    {
        $this->cadcaixacontacorrentetipopagamento = $object;
        $this->cadcaixacontacorrentetipopagamento_id = $object->id;
    }
    
    /**
     * Method get_cadcaixacontacorrentetipopagamento
     * Sample of usage: $movcaixacontacorrente->cadcaixacontacorrentetipopagamento->attribute;
     * @returns Cadcaixacontacorrentetipopagamento instance
     */
    public function get_cadcaixacontacorrentetipopagamento()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrentetipopagamento))
            $this->cadcaixacontacorrentetipopagamento = new Cadcaixacontacorrentetipopagamento($this->cadcaixacontacorrentetipopagamento_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrentetipopagamento;
    }    

    public function get_nome_caixacontacorrentetipopagamento()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrentetipopagamento))
            $this->cadcaixacontacorrentetipopagamento = new Cadcaixacontacorrentetipopagamento($this->cadcaixacontacorrentetipopagamento_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrentetipopagamento->caixacontacorrentetipopagamento;
    }  

    public function store()
    {
        // store the object itself
        parent::store();
        
    }    

}
