<?php
/**
 * MovcaixacontacorrenteTransf Active Record
 * @author  <your-name-here>
 */
class MovcaixacontacorrenteTransf extends TRecord
{
    const TABLENAME = 'movcaixacontacorrente_transf';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcaixacontacorrentetipotransf;
    private $cadcaixacontacorrente;
    private $movcaixacontacorrente;
    private $cadempresa;
    private $system_user;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('cadcaixacontacorrentetipotransf_id');
        parent::addAttribute('historico');
        parent::addAttribute('datalancamento');
        parent::addAttribute('valor');
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('cre_cadcaixacontacorrente_id');
        parent::addAttribute('deb_cadcaixacontacorrente_id');
        parent::addAttribute('system_user_id');
    }

    
    /**
     * Method set_cadcaixacontacorrentetipotransf
     * Sample of usage: $movcaixacontacorrente_transf->cadcaixacontacorrentetipotransf = $object;
     * @param $object Instance of Cadcaixacontacorrentetipotransf
     */
    public function set_cadcaixacontacorrentetipotransf(Cadcaixacontacorrentetipotransf $object)
    {
        $this->cadcaixacontacorrentetipotransf = $object;
        $this->cadcaixacontacorrentetipotransf_id = $object->id;
    }
    
    /**
     * Method get_cadcaixacontacorrentetipotransf
     * Sample of usage: $movcaixacontacorrente_transf->cadcaixacontacorrentetipotransf->attribute;
     * @returns Cadcaixacontacorrentetipotransf instance
     */
    public function get_cadcaixacontacorrentetipotransf()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrentetipotransf))
            $this->cadcaixacontacorrentetipotransf = new Cadcaixacontacorrentetipotransf($this->cadcaixacontacorrentetipotransf_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrentetipotransf;
    }
    
    
    /**
     * Method set_cre_cadcaixacontacorrente
     * Sample of usage: $movcaixacontacorrente_transf->cre_cadcaixacontacorrente = $object;
     * @param $object Instance of Cadcaixacontacorrente
     */
    public function set_cre_cadcaixacontacorrente(Cadcaixacontacorrente $object)
    {
        $this->cadcaixacontacorrente = $object;
        $this->cre_cadcaixacontacorrente_id = $object->id;
    }
    
    /**
     * Method get_cre_cadcaixacontacorrente
     * Sample of usage: $movcaixacontacorrente_transf->cre_cadcaixacontacorrente->attribute;
     * @returns Cadcaixacontacorrente instance
     */
    public function get_cre_cadcaixacontacorrente()
    {
        // loads the associated object
        if (empty($this->cre_cadcaixacontacorrente))
            $this->cre_cadcaixacontacorrente = new Cadcaixacontacorrente($this->cre_cadcaixacontacorrente_id);
    
        // returns the associated object
        return $this->cre_cadcaixacontacorrente;
    }
    
    public function get_cre_caixacontacorrente()
    {
        $cadcaixacontacorrente = new Cadcaixacontacorrente($this->cre_cadcaixacontacorrente_id);    
        // returns the associated object
        return $cadcaixacontacorrente->id .' - ' . $cadcaixacontacorrente->caixacontacorrente;        
    }    

    /**
     * Method set_deb_cadcaixacontacorrente
     * Sample of usage: $movcaixacontacorrente_transf->deb_cadcaixacontacorrente = $object;
     * @param $object Instance of Cadcaixacontacorrente
     */
    public function set_deb_cadcaixacontacorrente(Cadcaixacontacorrente $object)
    {
        $this->cadcaixacontacorrente = $object;
        $this->deb_cadcaixacontacorrente_id = $object->id;
    }
    
    /**
     * Method get_deb_cadcaixacontacorrente
     * Sample of usage: $movcaixacontacorrente_transf->deb_cadcaixacontacorrente->attribute;
     * @returns Cadcaixacontacorrente instance
     */
    public function get_deb_cadcaixacontacorrente()
    {
        // loads the associated object
        if (empty($this->deb_cadcaixacontacorrente))
            $this->deb_cadcaixacontacorrente = new Cadcaixacontacorrente($this->deb_cadcaixacontacorrente_id);
    
        // returns the associated object
        return $this->deb_cadcaixacontacorrente;
    }

    public function get_deb_caixacontacorrente()
    {
        $cadcaixacontacorrente = new Cadcaixacontacorrente($this->deb_cadcaixacontacorrente_id);    
        // returns the associated object
        return $cadcaixacontacorrente->id .' - ' . $cadcaixacontacorrente->caixacontacorrente;        
    }      
    
    /**
     * Method set_cadempresa
     * Sample of usage: $movcaixacontacorrente_transf->cadempresa = $object;
     * @param $object Instance of Cadempresa
     */
    public function set_cadempresa(Cadempresa $object)
    {
        $this->cadempresa = $object;
        $this->cadempresa_id = $object->id;
    }
    
    /**
     * Method get_cadempresa
     * Sample of usage: $movcaixacontacorrente_transf->cadempresa->attribute;
     * @returns Cadempresa instance
     */
    public function get_cadempresa()
    {
        // loads the associated object
        if (empty($this->cadempresa))
            $this->cadempresa = new Cadempresa($this->cadempresa_id);
    
        // returns the associated object
        return $this->cadempresa;
    }
    
    
    /**
     * Method set_system_user
     * Sample of usage: $movcaixacontacorrente_transf->system_user = $object;
     * @param $object Instance of SystemUser
     */
    public function set_system_user(SystemUser $object)
    {
        $this->system_user = $object;
        $this->system_user_id = $object->id;
    }
    
    /**
     * Method get_system_user
     * Sample of usage: $movcaixacontacorrente_transf->system_user->attribute;
     * @returns SystemUser instance
     */
    public function get_system_user()
    {
        // loads the associated object
        if (empty($this->system_user))
            $this->system_user = new SystemUser($this->system_user_id);
    
        // returns the associated object
        return $this->system_user;
    }
    
    public function get_login_systemuser()
    {
        // loads the associated object
        if (empty($this->system_user))
            $this->system_user = new SystemUser($this->system_user_id);
    
        // returns the associated object
        return $this->system_user->login;            
    }

}
