<?php
/**
 * SystemUserCadcaixacontacorrente Active Record
 * @author  <your-name-here>
 */
class SystemUserCadcaixacontacorrente extends TRecord
{
    const TABLENAME = 'system_user_cadcaixacontacorrente';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcaixacontacorrente;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_user_id');
        parent::addAttribute('cadcaixacontacorrente_id');
        parent::addAttribute('cadempresa_id');
    }

    
    /**
     * Method set_cadcaixacontacorrente
     * Sample of usage: $system_user_cadcaixacontacorrente->cadcaixacontacorrente = $object;
     * @param $object Instance of Cadcaixacontacorrente
     */
    public function set_cadcaixacontacorrente(Cadcaixacontacorrente $object)
    {
        $this->cadcaixacontacorrente = $object;
        $this->cadcaixacontacorrente_id = $object->id;
    }
    
    /**
     * Method get_cadcaixacontacorrente
     * Sample of usage: $system_user_cadcaixacontacorrente->cadcaixacontacorrente->attribute;
     * @returns Cadcaixacontacorrente instance
     */
    public function get_cadcaixacontacorrente()
    {
        // loads the associated object
        if (empty($this->cadcaixacontacorrente))
            $this->cadcaixacontacorrente = new Cadcaixacontacorrente($this->cadcaixacontacorrente_id);
    
        // returns the associated object
        return $this->cadcaixacontacorrente;
    }
    


}
