<?php
/**
 * SystemUserCadempresa Active Record
 * @author  <your-name-here>
 */
class SystemUserCadempresa extends TRecord
{
    const TABLENAME = 'system_user_cadempresa';
    const PRIMARYKEY= 'id';
    const IDPOLICY =  'serial'; // {max, serial}
    
    
    private $cadcaixa;
    private $cadalmoxarifado;
    private $cadempresa;

    /**
     * Constructor method
     */
    public function __construct($id = NULL, $callObjectLoad = TRUE)
    {
        parent::__construct($id, $callObjectLoad);
        parent::addAttribute('system_user_id');
        parent::addAttribute('cadempresa_id');
        parent::addAttribute('cadalmoxarifado_id');
        parent::addAttribute('cadcaixa_id');
    }

    
    /**
     * Method set_cadcaixa
     * Sample of usage: $system_user_cadempresa->cadcaixa = $object;
     * @param $object Instance of Cadcaixa
     */
    public function set_cadcaixa(Cadcaixa $object)
    {
        $this->cadcaixa = $object;
        $this->cadcaixa_id = $object->id;
    }
    
    /**
     * Method get_cadcaixa
     * Sample of usage: $system_user_cadempresa->cadcaixa->attribute;
     * @returns Cadcaixa instance
     */
    public function get_cadcaixa()
    {
        // loads the associated object
        if (empty($this->cadcaixa))
            $this->cadcaixa = new Cadcaixa($this->cadcaixa_id);
    
        // returns the associated object
        return $this->cadcaixa;
    }
    
    
    /**
     * Method set_cadalmoxarifado
     * Sample of usage: $system_user_cadempresa->cadalmoxarifado = $object;
     * @param $object Instance of Cadalmoxarifado
     */
    public function set_cadalmoxarifado(Cadalmoxarifado $object)
    {
        $this->cadalmoxarifado = $object;
        $this->cadalmoxarifado_id = $object->id;
    }
    
    /**
     * Method get_cadalmoxarifado
     * Sample of usage: $system_user_cadempresa->cadalmoxarifado->attribute;
     * @returns Cadalmoxarifado instance
     */
    public function get_cadalmoxarifado()
    {
        // loads the associated object
        if (empty($this->cadalmoxarifado))
            $this->cadalmoxarifado = new Cadalmoxarifado($this->cadalmoxarifado_id);
    
        // returns the associated object
        return $this->cadalmoxarifado;
    }
    
    
    /**
     * Method set_cadempresa
     * Sample of usage: $system_user_cadempresa->cadempresa = $object;
     * @param $object Instance of Cadempresa
     */
    public function set_cadempresa(Cadempresa $object)
    {
        $this->cadempresa = $object;
        $this->cadempresa_id = $object->id;
    }
    
    /**
     * Method get_cadempresa
     * Sample of usage: $system_user_cadempresa->cadempresa->attribute;
     * @returns Cadempresa instance
     */
    public function get_cadempresa()
    {
        // loads the associated object
        if (empty($this->cadempresa))
            $this->cadempresa = new Cadempresa($this->cadempresa_id);
    
        // returns the associated object
        return $this->cadempresa;
    }
    


}
